
#pragma warning(disable : 4996)
#define  _CRT_SECURE_NO_WARNINGS
#include "AIScope.h"
#include "setting.h"
#include "winmain.h"
#include "visual.h"

#include "ResetBond.h"
#include "ResetColorByPressure.h"


extern bool g_updateFlag;
				
static const double STEREO_EYELENGTH = 0.6;



AIScope::AIScope() : 
	m_mouse_toggle(0),
	m_outNumBMP(0),
	m_selected_id(-1)
//	m_num_files(0)
{
	m_camera = new CameraGL();

}

AIScope::~AIScope(){
	delete m_camera;
}



int AIScope::Resize(int w, int h){
	m_client_w = w;
	m_client_h = h;

	return 1;
}


	
int AIScope::OpenFile(const TCHAR* filepath){
	
	FileInfo* finfo = new FileInfo();
	
	if(OpenDataFile(filepath, finfo)){

		
		mat33d axis;
		vec3d org;

		switch(finfo->type){
		case FILETYPE_ATOM:
			{
			if((g_visual_atomcolor==VISUAL_ATOMCOLOR_BONDNUM) || g_visual_bond){
				glips_ResetBond(finfo->atm->GetDataPointer(), &(finfo->bond), g_bond_cutoff);
			}
			if((g_visual_atomcolor==VISUAL_ATOMCOLOR_PRESSURE)){
				//glips_ResetColorByPressure(finfo->atm->GetDataPointer(), &(finfo->bond));
				glips_ResetColorByPx(finfo->atm->GetDataPointer(), &(finfo->bond));
			}

			ATOMS_DATA* dat = finfo->atm->GetDataPointer();
			axis = dat->boxaxis;
			org = dat->boxorg;
			}
			break;
			//{h̍ČvZs//
			//finfo->atm->SetBondCheckFlags(g_visual_bond | (g_visual_atomcolor == 1));
		case FILETYPE_TRAJ:
		

			finfo->bca->GetBoxaxis(&axis, &org);
			break;
			
		case FILETYPE_FIELD:
			finfo->field->GetBoxaxis(&axis, &org);
			break;
		case FILETYPE_LMC:
			finfo->lmc->GetBoxaxis(&axis, &org);
			break;
		}

		
		//J̐ݒ
		if(finfo->type != FILETYPE_NULL){
		
			double max_side = (double)max(max(axis.m11, axis.m22), axis.m33);
		
			vec3d cnt = ((axis.a + axis.b + axis.c) * 0.5 + org);
			m_camera->Init(max_side, cnt.x, cnt.y, cnt.z);
		}

		m_files.push_back(finfo);

		return 1;
	}else{
		delete finfo;
	}
	return 0;
}


int AIScope::OpenDataFile(const TCHAR* filepath, FileInfo* finfo){

	
	finfo->type = FILETYPE_NULL;
	
	//V[gl[烍Ol[̎擾
	unsigned int filenamelen = GetLongPathName(filepath, NULL, 0);
	if(_tcslen(filepath) < filenamelen){
		finfo->filepath = new TCHAR[filenamelen+1];
		GetLongPathName( filepath, finfo->filepath, filenamelen+1);
	}else{
		finfo->filepath = _tcsdup(filepath);
	}

	//t@C,gq̕.
	TCHAR* p = _tcsrchr(finfo->filepath, _T('.'));
	finfo->ext = p + 1;
	p = _tcsrchr(finfo->filepath, _T('\\'));
	if(p){
		finfo->dirlen = (int)(p - finfo->filepath) + 1;
		finfo->filename = p + 1;
	}else{
		finfo->filename = finfo->filepath;
	}
	
	
	//qʒut@ĈƂ.
	if((_tcscmp(finfo->ext,_T("fad")) == 0) 
		|| (_tcscmp(finfo->ext,_T("fa2")) == 0) 
		|| (_tcscmp(finfo->ext,_T("xyz")) == 0) 
		|| (_tcscmp(finfo->ext,_T("md2")) == 0) 
		|| (_tcscmp(finfo->ext,_T("md3")) == 0) 
		|| (_tcscmp(finfo->ext,_T("md")) == 0) 
		|| (_tcscmp(finfo->ext,_T("pdb")) == 0)) {

		finfo->atm = new MDLoader(finfo->filepath);
		
		if (finfo->atm->GetDataPointer() == NULL){
			//ǂݍݎs.
			delete finfo->atm;
			finfo->atm = NULL;
		}else{

			
			finfo->type = FILETYPE_ATOM;
			
		}

	//gWFNg[t@ĈƂ
	}else if((_tcscmp(finfo->ext,_T("txt")) == 0)
		|| (_tcscmp(finfo->ext,_T("traj")) == 0) ){
		
		
		finfo->bca = new BCALoader(finfo->filepath);
		Trajectory* traj = finfo->bca->GetData();
		if( !traj ){
			MessageBox(NULL, _T("error:trajectory"), _T("error"), MB_OK);
		}else{
			finfo->type = FILETYPE_TRAJ;
		}
		
		//g_visual_traj = VISUAL_TRAJ_ON;
		
		
		
	//fieldt@ĈƂ.
	}else if((_tcscmp(finfo->ext,_T("cube")) == 0)
		|| (_tcscmp(finfo->ext,_T("bif")) == 0)) {	
		
		Field3DLoader* field = new Field3DLoader();
		if(field->Load(finfo->filepath)){
			delete field;
			
		}else{
			finfo->type = FILETYPE_FIELD;
			finfo->field = field;
			
		
		}
		

		
	//fieldt@ĈƂ.
	}else if(_tcscmp(finfo->ext,_T("lmc")) == 0){	
		
		LMC_Holder* lmc = new LMC_Holder();
		
		if(lmc->Load(finfo->filepath)){
			delete lmc;
			lmc = NULL;
		}else{
			finfo->type = FILETYPE_LMC;
			//finfo->lmcRenderer = new LMCRendererGL();
		
		}
		finfo->lmc = lmc;
	}



    return 1;
    
}



int AIScope::ReloadFile(){

	FileInfo refinfo;
	

	if( OpenDataFile(m_files[0]->filepath, &refinfo)){

		if(refinfo.type == FILETYPE_ATOM){
			delete (m_files[0]->atm);
			//delete (m_files.current->atomRenderer);
		
			m_files[0]->atm = refinfo.atm;
			//m_files.current->atomRenderer = refinfo.atomRenderer;

			ATOMS_DATA* dat = m_files[0]->atm->GetDataPointer();

		
			if((g_visual_atomcolor==VISUAL_ATOMCOLOR_BONDNUM) || g_visual_bond){
				glips_ResetBond(m_files[0]->atm->GetDataPointer(), &(m_files[0]->bond), g_bond_cutoff);
			}
			if((g_visual_atomcolor==VISUAL_ATOMCOLOR_PRESSURE)){
				glips_ResetColorByPx(m_files[0]->atm->GetDataPointer(), &(m_files[0]->bond));
			}
		}
		//֐IrefinfoƋatmĵł܂//
		refinfo.type = FILETYPE_NULL;
		return 1;
	}

	return 0;
	
}

void AIScope::DisplayGL15(){
	
	//RenderingGL15(&m_files, m_num_files, m_client_w, m_client_h, m_camera);
	RenderingGL15_2(m_files, m_client_w, m_client_h, 0, 0, m_client_w, m_client_h, m_camera, g_visual_projection);
}

void AIScope::DisplayDX11(){
	RenderingDX11(m_files, m_client_w, m_client_h, m_camera);
}

int AIScope::MouseDownTrans(int x, int y, WPARAM wParam){
	/*
	if(m_mouse_toggle == 0){
		int cx = m_client_w/2;
		int cy = m_client_h/2;
			

		if((abs(x-cx) < 100) && (abs(y-cy) < 100)){
			m_mouse_toggle = 10;
		}else{
			m_mouse_toggle = 20;
		}
	*/
		m_mouse_toggle_ctr.x = x;
		m_mouse_toggle_ctr.y = y;
		m_camera->DragStart();
	//}

	return 0;
}


int AIScope::MouseDownRot(int x, int y, WPARAM wParam){
	/*
	if(m_mouse_toggle == 0){
		int cx = m_client_w/2;
		int cy = m_client_h/2;
			

		if((abs(x-cx) < 100) && (abs(y-cy) < 100)){
			m_mouse_toggle = 10;
		}else{
			m_mouse_toggle = 20;
		}
	*/
		m_mouse_toggle_ctr.x = x;
		m_mouse_toggle_ctr.y = y;
		m_camera->DragStart();
	//}

	return 0;
}

int AIScope::MouseUpTrans(){
	/*if(m_mouse_toggle){
		m_mouse_toggle = 0;
	}
	*/
	return 0;
}

int AIScope::MouseUpRot(){
	/*if(m_mouse_toggle){
		m_mouse_toggle = 0;
	}
	*/
	return 0;
}

int AIScope::MouseMoveTrans(int x, int y, WPARAM wParam){
				
		x -= m_mouse_toggle_ctr.x;
		y -= m_mouse_toggle_ctr.y;
		if( x | y ){	//ړꍇ̂
						
			m_camera->DragTranslate(x, -y, m_client_w, m_client_h);

			return 1;
		}

	return 0;
	
}

int AIScope::MouseMoveRot(int x, int y, WPARAM wParam){
					
	x -= m_mouse_toggle_ctr.x;
	y -= m_mouse_toggle_ctr.y;
	if( x | y ){	//ړꍇ̂
	
		m_camera->DragRotate(x, -y, m_client_w, m_client_h);

		return 1;

	}

	return 0;
	
}


int AIScope::ZoomIn(double d){
	m_mouse_toggle = 0;	//sړ,]̉//
	m_camera->FocusDown( -0.1 * (double)d );
	return 1;
}

/*
XN[W(x,y)VRԒ̌qI
*/
int AIScope::SelectAtom(int x, int y, double cutoff){
			
	int sid = -1;


	
	if(! m_files.empty()){

		vec3d vray, vorg;
		m_camera->GetRAY(x, y, m_client_w, m_client_h, &vray, &vorg);
		

		ATOMS_DATA *dat = m_files[0]->atm->GetDataPointer();
		
//		dat->r[0].x = (float)(vray.x + vorg.x);
//		dat->r[0].y = (float)(vray.y + vorg.y);
//		dat->r[0].z = (float)(vray.z + vorg.z);
		
		vray = Unit(vray);
		vec3f* r = dat->r;
		int count = dat->pcnt;
		double min_dr2 = DBL_MAX;
		for(int i = 0; i <count; i++){
			vec3d ro;
			ro.x = (double)(r[i].x) - vorg.x;
			ro.y = (double)(r[i].y) - vorg.y;
			ro.z = (double)(r[i].z) - vorg.z;
			double len1 = ro * vray;
			double dr2 = (ro*ro) - len1*len1;
			if( dr2 < min_dr2 ) {
				min_dr2 = dr2;
				sid = i;
			}
		}
		
		if(min_dr2 > cutoff * cutoff){
			sid = -1;
		}else{
			
			m_selected_id = sid;
		}
		

	}
		
	return sid;
}



//w肵t[܂őSẴt@C̃^Ct[Wv.
//ۂɈړt[maximumԂ.
//minimum0̂͂Ȃ̂
//߂l(maxframe) < (timeframe)ȂŌ̃t[ɓB؋.
int AIScope::FrameJump(int timeframe){

	int maxframe = 0;
	


	for(ITP_FileList it = m_files.begin(); it != m_files.end(); it++){
		FileInfo* fi = *it;
		int res;

		switch(fi->type){
		case FILETYPE_ATOM:
			{
				int prevno = fi->atm->GetFrameNum();
				res = fi->atm->SetFrameNum(timeframe);
				if(prevno  != res){
					if((g_visual_atomcolor==VISUAL_ATOMCOLOR_BONDNUM)  || g_visual_bond){
						glips_ResetBond(fi->atm->GetDataPointer(), &(fi->bond), g_bond_cutoff);
					//	fi->atomRenderer->ClearVRAM();
					}
					if((g_visual_atomcolor==VISUAL_ATOMCOLOR_PRESSURE)){
						glips_ResetColorByPx(fi->atm->GetDataPointer(), &(fi->bond));
					}
				}
			}
			break;
		case FILETYPE_TRAJ:
			res = fi->bca->SetFrameNum(timeframe);
			break;
		case FILETYPE_LMC:
			res = fi->lmc->SetFrameNum(timeframe);
			break;
		case FILETYPE_FIELD:
			res = fi->field->SetFrameNum(timeframe);
			break;
		default:
			res = 0;
		
			break;
		}

		if(maxframe < res) maxframe = res;
	}

	g_updateFlag = true;
				

	return maxframe;
}



void AIScope::OutputStereoBMPGL(){
	
	TCHAR spath[MAX_PATH];
	

	//Eڗp摜
	FileInfo* current = m_files[0];
	
	int length = (int)(current->ext - current->filepath - 1);
	_tcsncpy(spath, current->filepath, length);
	_stprintf(spath + length,_T("%d_right.bmp"), m_outNumBMP);
	//m_outNumBMP++;
	printf("%s\n",spath);

	m_camera->PushState();
	m_camera->SetStereoMode(2.0);
	double radius = m_camera->GetForcusDistance();
	double delta_aglxy = STEREO_EYELENGTH / radius;
	m_camera->RotatePosOnUpAxis(delta_aglxy);

	OutputBMfromGLMag(m_files, spath, m_client_w, m_client_h, 1, m_camera);

	//ڗp摜
	_stprintf(spath + length,_T("%d_left.bmp"), m_outNumBMP);
	m_outNumBMP++;
	printf("%s\n",spath);

	m_camera->RotatePosOnUpAxis(-2.0*delta_aglxy);
	
//				cam_info.focus_y -= width2 * cos(cam_info.aglxy);
//				cam_info.focus_x += width2 * sin(cam_info.aglxy);

	OutputBMfromGLMag(m_files, spath, m_client_w, m_client_h, 1, m_camera);

	//g_camera->RotatePosOnUpAxis(delta_aglxy);
	m_camera->PullState();

}

void AIScope::OutputSequentialBMPGL(){

	TCHAR spath[MAX_PATH];

	FileInfo* current = m_files[0];
	size_t length = current->ext - current->filepath - 1;
	_tcsncpy(spath, current->filepath, length);
		

		
	int res = 0;
	while(res==0){

		//t@C//
		if(m_outNumBMP < 10){
			_stprintf(spath + length,_T("000%d.bmp"), m_outNumBMP);
		}else if(m_outNumBMP < 100){
			_stprintf(spath + length,_T("00%d.bmp"), m_outNumBMP);
		}else if(m_outNumBMP < 1000){
			_stprintf(spath + length,_T("0%d.bmp"), m_outNumBMP);
		}else{
			_stprintf(spath + length,_T("%d.bmp"), m_outNumBMP);
		}
		m_outNumBMP++;

		//摜
		OutputBMfromGLMag(m_files, spath, m_client_w, m_client_h, 1, m_camera);

		Sleep(0);
		//1t[i߂
		res = PlayMovie();
	}




}

//analyze for view//
int AIScope::ResetBond(){
	
	for(ITP_FileList it = m_files.begin(); it != m_files.end(); it++){
		FileInfo* fi = *it;
		if(fi->type == FILETYPE_ATOM){
			glips_ResetBond(fi->atm->GetDataPointer(), &(fi->bond), g_bond_cutoff);
		}
	}
	
	return 1;
}

int AIScope::ResetColorByPressure(){
	
	for(ITP_FileList it = m_files.begin(); it != m_files.end(); it++){
		FileInfo* fi = *it;
		if(fi->type == FILETYPE_ATOM){
			//glips_ResetColorByPressure(fi->atm->GetDataPointer(), &(fi->bond));
			glips_ResetColorByPx(fi->atm->GetDataPointer(), &(fi->bond));
		}
	}
	
	return 1;
}

