
#ifndef AIScopeEvent_H
#define AIScopeEvent_H


#pragma once
#define _CRT_SECURE_NO_WARNINGS
#define _CRT_SECURE_NO_DEPRECATE

#include <stdlib.h>
#include <stdio.h>



#define WIN32_LEAN_AND_MEAN             // Windows wb_[gpĂȂO܂B
#include <windows.h>
#include <tchar.h>

#include "vec3.h"

#include "camera.h"
#include "filelist.h"
//#include "ai_funcs.h"
//#include "ai_molecule.h"

#include "RenderGL15.h"

#include "RenderDX11.h"

/*
#include <GL/gl.h>		//OpenGLpɕKv<br />
#include <GL/glu.h>		//gluPerspectiveg߂ɃCN[h
#pragma comment( lib , "opengl32.lib" )	//OpenGLpCuN
#pragma comment( lib , "glu32.lib" )	//glu֐pCuN
*/

//#include "vec3.h"

//callback function to be called by the AIScope class//

//typedef void (*REDISPLAY_FUNC)();

class AIScope
{
private:

	//REDISPLAY_FUNC cbRedisplay;

	VP_FileList m_files;		//Jt@C̃Xg.
	//int m_num_files;
	CameraGL* m_camera;

	
	int m_client_w;
	int m_client_h;

	//mouse operation//
	int m_mouse_toggle;
	POINT m_mouse_toggle_ctr;

	int m_selected_id;
	
	int m_outNumBMP;

	//file load//
	int AIScope::OpenDataFile(const TCHAR* filepath, FileInfo* finfo);

public:
	
	AIScope();
	virtual ~AIScope();

//	void CallBackRedisplay(REDISPLAY_FUNC func){ cbRedisplay = func;};
	
	BOOL ExistData(){return (BOOL)(m_files.size());};

	//events//
	int Resize(int w, int h);

	//file load//
	int OpenFile(const TCHAR* filepath);
	int ReloadFile();
	
	//view by OpenMX//
	void DisplayGL15();

	//view by DisplayDX11//
	void DisplayDX11();


	//Jn////////////////////////////////////////////////
	int MouseDownTrans(int x, int y, WPARAM wParam);
	int MouseUpTrans();
	int MouseMoveTrans(int x, int y, WPARAM wParam);
	int MouseDownRot(int x, int y, WPARAM wParam);
	int MouseUpRot();
	int MouseMoveRot(int x, int y, WPARAM wParam);
	int ZoomIn(double d);

	int TranslateUp(double d){
		m_camera->TargetMoveToUp(d);
		return 1;
	};

	int TranslateLeft(double d){
		m_camera->TargetMoveToSide(d);
		return 1;
	};

	int RotateOnUpAxis(double rad){
		m_camera->RotatePosOnUpAxis(rad);
		return 1;
	};

	int RotateOnLeftAxis(double rad){
		m_camera->RotatePosToUp(rad);
		return 1;
	};

	int SetYawPitchRoll(double yaw, double pitch, double roll){
		m_camera->SetYawPitchRoll(yaw, pitch, roll);
		return 1;
	};

	int SetRotationMatrix(const float* matrix){
		m_camera->SetRotationMatrix(matrix);
		return 1;	
	};
////////////////////////////////////////////////Jn//
	





	int SelectAtom(int x, int y, double cutoff);

	//analyze for view//
	int ResetBond();
	int ResetColorByPressure();

#if 0
	//set view mode//
	int SetViewMode(int type, int mode){
		m_rendererAtom->SetMode(type, mode, m_files.current->atm->GetDataPointer());
		return 1;
	}
#endif 

	//get infomation//
	int GetFileName(TCHAR* buffer){
		if(! m_files.empty()){
			_tcscpy(buffer, m_files[0]->filename);
		}
		return 0;
	};
	
	int GetFilePath(TCHAR* buffer){
		if(! m_files.empty()){
			_tcscpy(buffer, m_files[0]->filepath);
		}
		return 0;
	};

	FILETYPE GetFileType(){
		if(! m_files.empty()){
			return m_files[0]->type;
		}
		return FILETYPE_NULL;
	};

	
	FileInfo* GetFileInfo(){
		if(! m_files.empty()){
			return m_files[0];
		}
		return NULL;
	};

	ATOMS_DATA* GetAtomData(){
		if(! m_files.empty()){
			return m_files[0]->atm->GetDataPointer();
		}
		return NULL;
	};

	int GetSelectedAtomID(){ return m_selected_id;};
		
	int GetSelectedAtomInfo(int *a_knd, vec3d* a_r){
		ATOMS_DATA* dat = m_files[0]->atm->GetDataPointer();
		m_selected_id;
		if(a_knd && (dat->knd)){
			*a_knd = dat->knd[m_selected_id];
		}
		if(a_r && (dat->r)){
			a_r->Set(dat->r[m_selected_id].x, dat->r[m_selected_id].y, dat->r[m_selected_id].z);
		}
		return m_selected_id;
	};

	//movie frame operation//
	int FrameJump(int timeframe);

	//output data//
	void OutputBMPMagGL(const TCHAR* path, int magnify){
		OutputBMfromGLMag(m_files, path, m_client_w, m_client_h, magnify, m_camera);
	}
	
	void OutputFieldRaytracing(const TCHAR* path, int magnify){
		OutputRaytracing(m_files[0], path, m_client_w, m_client_h, magnify, m_camera);
	}
	
	void OutputStereoBMPGL();
	void OutputSequentialBMPGL();

	void OutputBMPMagDX11(const TCHAR* path, int magnify){
		OutputDX11(m_files, path, m_client_w, m_client_h, magnify, m_camera);
	}


	//cross section//
	void SetCrosssection(int section, int sprit){
		/*
		ATOMS_DATA* dat = m_files.current->atm->GetDataPointer();
		mat33f axis = dat->boxaxis;
		double max_side = (double)max(max(axis.m11, axis.m22), axis.m33);
		*/

		m_camera->SetViewFront(section, sprit);
	};

	void ResetCrosssection(){
		/*
		ATOMS_DATA* dat = m_files.current->atm->GetDataPointer();
		mat33f axis = dat->boxaxis;
		double max_side = (double)max(max(axis.m11, axis.m22), axis.m33);
		*/
		m_camera->ResetViewFront();
	};

};

#endif // AIScopeEvent_H