// AtomRendererDX11.cpp: AtomRendererDX11 NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "AtomRendererDX11.h"

#include "atomic_color.h"

#define _USE_MATH_DEFINES
#include <math.h>
#include <string.h>


#pragma warning(disable : 4996)

extern size_t g_max_vram_size;

#define		ATOM_RADIUS		(0.25)

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////



AtomRendererDX11::AtomRendererDX11(DX11_CORE* dx11_core, CommonShader* comShader) : 
	BasicRenderer(dx11_core, comShader, 0,0),
//		m_vertex_max_count(0),
//		m_texturepath(NULL),
	//DXnIuWFNgϐNULLZbg.
//		m_pGeometryShader(NULL),
//		m_pTextureRV(NULL),
//		m_pSampler(NULL), 
	m_pDepthStencilState(NULL),
	m_pRasterizerState(NULL),
	m_vram_size( 0 ),
	m_prev_render_dat( NULL ),
	m_vbo_vertex( NULL ),
	m_vbo_indexes( NULL ),

	m_visual_bond( VISUAL_BOND_PIPE ),
	m_color_table( NULL ),

	m_sphere_pos( NULL ),
	m_sphere_nor( NULL ),
	m_sphere_idx( NULL ),
	m_bond_pos( NULL ),
	m_bond_nor( NULL ),
	m_bond_idx( NULL )
{
	
	memset(&m_prev_vis, 0, sizeof(VISUAL_SETTING));

	//|Sf̏
//	InitSphere( ATOM_RADIUS, 6, 8);
//	InitBond( 0.05f, 8 );
	
	InitShader();
}


AtomRendererDX11::~AtomRendererDX11(){

	delete [] m_vbo_vertex;
	delete [] m_vbo_indexes;

	delete [] m_sphere_pos;
	delete [] m_sphere_nor;
	delete [] m_sphere_idx;
	delete [] m_bond_pos;
	delete [] m_bond_nor;
	delete [] m_bond_idx;
	delete [] m_color_table;
	
	SAFE_RELEASE(m_pDepthStencilState );
	SAFE_RELEASE(m_pRasterizerState);
	//SAFE_RELEASE(pBlendState);

    

}



HRESULT AtomRendererDX11::InitShader(){
	TCHAR filepath[MAX_PATH];
	
//Vertex Shader--------------------------------------
	
    D3D11_INPUT_ELEMENT_DESC layout[] =
    {
        { "POSITION", 0, DXGI_FORMAT_R32G32B32_FLOAT, 0, 0, D3D11_INPUT_PER_VERTEX_DATA, 0 },
		{ "NORMAL", 0, DXGI_FORMAT_R32G32B32_FLOAT, 0, 12, D3D11_INPUT_PER_VERTEX_DATA, 0 },
		{ "COLOR", 0, DXGI_FORMAT_R8G8B8A8_UNORM, 0, 24, D3D11_INPUT_PER_VERTEX_DATA, 0 },

    };
	UINT numElements = ARRAYSIZE( layout );
	GetAttachedFileName(filepath, _T("vs_color.cso"));
	m_pVertexShader = m_comShader->LoadVertexShader(filepath, "main", "vs_4_0", layout, numElements, &m_pVertexLayout);


//Pixel Shader-----------------------------------------
	GetAttachedFileName(filepath, _T("ps_color.cso"));
	m_pPixelShader = m_comShader->LoadPixelShader(filepath, "main", "ps_4_0");


//-----------------------------------------------------------------------
//Constant buffer̍쐬
//constant bufferƂ́AJʒu⃏[hϊsȂ,
//CPUGPŮeXbhɃANZXobt@.
//[hs:fglobalԂɐݒuƂ̈ʒu(sړ)(])Zbgs.
//r[s:J猩Wn֕ϊ.
//ˉes:2W֕ϊ


	//projection, view, world matrixes
	D3D11_BUFFER_DESC bd;
	bd.ByteWidth = sizeof( mat44f )*3 + sizeof(float)*4;
    bd.Usage = D3D11_USAGE_DYNAMIC;
    bd.BindFlags = D3D11_BIND_CONSTANT_BUFFER;
	bd.CPUAccessFlags = D3D11_CPU_ACCESS_WRITE;	//CPȔ
	bd.MiscFlags = 0;
	bd.StructureByteStride=0;
	//SUBRESOURCEɂ鏉l͐ݒ肵Ȃ

    HRESULT hr = m_dx11_core->pd3dDevice->CreateBuffer( &bd, NULL, &m_pWVPBuffer );
    if( FAILED( hr ) )
        return hr;

	
	
// uhEXe[gEIuWFNg̍쐬
	// p[eBNpuhEXe[gEIuWFNg
	D3D11_BLEND_DESC BlendDesc;
	ZeroMemory(&BlendDesc, sizeof(D3D11_BLEND_DESC));
	BlendDesc.AlphaToCoverageEnable    = FALSE;
	BlendDesc.IndependentBlendEnable   = FALSE;
	BlendDesc.RenderTarget[0].BlendEnable           = FALSE;
	BlendDesc.RenderTarget[0].BlendOp               = D3D11_BLEND_OP_ADD;
	BlendDesc.RenderTarget[0].SrcBlend              = D3D11_BLEND_SRC_ALPHA;//D3D11_BLEND_ONE;
	BlendDesc.RenderTarget[0].DestBlend             = D3D11_BLEND_ONE;
	BlendDesc.RenderTarget[0].BlendOpAlpha          = D3D11_BLEND_OP_ADD;
	BlendDesc.RenderTarget[0].SrcBlendAlpha         = D3D11_BLEND_ZERO;
	BlendDesc.RenderTarget[0].DestBlendAlpha        = D3D11_BLEND_ZERO;
	BlendDesc.RenderTarget[0].RenderTargetWriteMask = D3D11_COLOR_WRITE_ENABLE_ALL;
	hr = m_dx11_core->pd3dDevice->CreateBlendState(&BlendDesc, &m_pBlendState);

	//[xobt@݂Ȃ.
// fvXEXe[gEIuWFNg̍쐬
	// p[eBNpfvXEXe[gEIuWFNg
	//|CgXvCgł̓fvXobt@̃`FbNāAXV͂Ȃ.
	D3D11_DEPTH_STENCIL_DESC DepthStencilState;
	ZeroMemory(&DepthStencilState, sizeof(D3D11_DEPTH_STENCIL_DESC));
	DepthStencilState.DepthEnable = TRUE;
	DepthStencilState.DepthWriteMask = D3D11_DEPTH_WRITE_MASK_ALL;	//[xobt@݂.
	DepthStencilState.DepthFunc = D3D11_COMPARISON_LESS;
	DepthStencilState.StencilEnable = FALSE;
	DepthStencilState.StencilReadMask = D3D11_DEFAULT_STENCIL_READ_MASK;
	DepthStencilState.StencilWriteMask = D3D11_DEFAULT_STENCIL_WRITE_MASK;
//	DepthStencilState.StencilFunc = D3D11_STENCIL_OP_KEEP;
//	DepthStencilState.StencilDepthFailOp = D3D11_STENCIL_OP_KEEP;
//	DepthStencilState.StencilPassOp = D3D11_STENCIL_OP_KEEP;
//	DepthStencilState.StencilFailOp = D3D11_COMPARISON_ALWAYS;
	hr = m_dx11_core->pd3dDevice->CreateDepthStencilState(&DepthStencilState, &m_pDepthStencilState);


	
	
// X^CU̍쐬//
	//JO𐧌//
	D3D11_RASTERIZER_DESC RasterizerState;
	ZeroMemory(&RasterizerState, sizeof(D3D11_RASTERIZER_DESC));
	RasterizerState.FillMode = D3D11_FILL_SOLID;
	RasterizerState.CullMode = D3D11_CULL_BACK;
	RasterizerState.FrontCounterClockwise = TRUE;
	RasterizerState.DepthBias = 0;
	RasterizerState.DepthBiasClamp = 0;
	RasterizerState.SlopeScaledDepthBias = 0;
	RasterizerState.DepthClipEnable = FALSE;
	RasterizerState.ScissorEnable = FALSE;
	RasterizerState.MultisampleEnable = FALSE;
	RasterizerState.AntialiasedLineEnable = FALSE;
	hr = m_dx11_core->pd3dDevice->CreateRasterizerState(&RasterizerState, &m_pRasterizerState);

	
    return S_OK;
}


void AtomRendererDX11::Draw(UINT index_count, vec3f* positions){

	//ϊs
	mat44f world_matrix;
	world_matrix.SetIdentity();
	
	//Blendݒ///////////////////////////////
	//ftHg̃uhXe[g.
	ID3D11BlendState*		org_pBlendState;
	FLOAT org_BlendFactor[4];
	UINT org_SampleMask;
	if(m_pBlendState){
		m_dx11_core->pd3dDC->OMGetBlendState(&org_pBlendState, org_BlendFactor, &org_SampleMask);
		m_dx11_core->pd3dDC->OMSetBlendState(m_pBlendState, org_BlendFactor, org_SampleMask);
	}

	//XeVݒ////////////////////////////////////
	//ftHg̃XeVXe[g.
	ID3D11DepthStencilState*		org_pDepthStencilState;
	UINT org_StencilRef;
	if(m_pDepthStencilState){
		m_dx11_core->pd3dDC->OMGetDepthStencilState(&org_pDepthStencilState, &org_StencilRef);
		m_dx11_core->pd3dDC->OMSetDepthStencilState(m_pDepthStencilState, 0);
	}
	
	//X^CUݒ////////////////////////////////////
	//ftHg̃X^CU.
	if(m_pRasterizerState){
		m_dx11_core->pd3dDC->RSSetState(m_pRasterizerState);
	}


	// Set the input layout
    m_dx11_core->pd3dDC->IASetInputLayout( m_pVertexLayout );
    // Set primitive topology
    m_dx11_core->pd3dDC->IASetPrimitiveTopology( D3D11_PRIMITIVE_TOPOLOGY_TRIANGLELIST );

	//萔obt@̏.
	D3D11_MAPPED_SUBRESOURCE mappedResource;
	m_dx11_core->pd3dDC->Map( m_pConstantBuffers[0], 0, D3D11_MAP_WRITE_DISCARD, 0,&mappedResource);
	CopyMemory(mappedResource.pData, &world_matrix, sizeof(mat44f));
	CopyMemory((mat44f*)mappedResource.pData + 1, m_pViewMatrix, sizeof(mat44f));
	CopyMemory((mat44f*)mappedResource.pData + 2, m_pProjectionMatrix, sizeof(mat44f));
	//CopyMemory((mat44f*)mappedResource.pData + 3, &m_pPointSize, sizeof(vec2f));
	m_dx11_core->pd3dDC->Unmap( m_pConstantBuffers[0], 0);


	//obt@̃Zbg.	
    UINT offset = 0;
    UINT stride = sizeof( VERTEX_F3F3UI1 );
    m_dx11_core->pd3dDC->IASetVertexBuffers( 0, 1, &m_pVertexBuffer, &stride, &offset );
	m_dx11_core->pd3dDC->IASetIndexBuffer( m_pIndexBuffer, m_index_format, 0 );
	
	//IȒ_obt@(CX^Xp)̍XV (UpdateSubresourcegꍇ).
	//ړĨobt@Usage = D3D11_USAGE_DEFAULT, CPUAccessFlags = 0.
	//ONULL̎VertexBuffer(VRAM)ƓTCYRs[̂,
	//Rs[(CPU)VertexBufferȏ̃TCYmۂĂȂ΂ȂȂ.
	//̂Ƃ܁EZ͖.
//	m_dx11_core->pd3dDC->UpdateSubresource( m_pVertexBuffer, 0, NULL, positions, 0, 0);//sizeof(vec3f) * particle_count
	//: Map/UnmapUpdateSubresourceł͖wǑx͂Ȃ.


    // Render materials
	m_dx11_core->pd3dDC->VSSetShader( m_pVertexShader, NULL, 0 );
	m_dx11_core->pd3dDC->VSSetConstantBuffers(0, 1, m_pConstantBuffers);
	
	m_dx11_core->pd3dDC->GSSetShader( NULL, NULL, 0 );
//	m_dx11_core->pd3dDC->GSSetShader( m_pGeometryShader, NULL, 0 );
//	m_dx11_core->pd3dDC->GSSetConstantBuffers(0, 1, m_pConstantBuffers);
		
	m_dx11_core->pd3dDC->PSSetShader( m_pPixelShader, NULL, 0 );
//	m_dx11_core->pd3dDC->PSSetShaderResources( 0, 1, &(m_pTextureRV) );
//	m_dx11_core->pd3dDC->PSSetSamplers( 0, 1, &m_pSampler );
	m_dx11_core->pd3dDC->DrawIndexed( index_count, 0, 0);

	//Blendݒ///////////////////////////////
	if(m_pBlendState){
		m_dx11_core->pd3dDC->OMSetBlendState(org_pBlendState, org_BlendFactor, org_SampleMask);
	}
	if(m_pDepthStencilState){
		m_dx11_core->pd3dDC->OMSetDepthStencilState(org_pDepthStencilState, org_StencilRef);
	}
}



//VBO̐ݒ
void AtomRendererDX11::Draw(ATOMS_DATA* dat, BOND_INFO* bond, const VISUAL_SETTING& vis){	//int j_mode, float Jmax
	

	//ATOMS_DATA* dat = GetDataPointer();
	if (dat == NULL) return;
	

	//vbõZbg
	int redraw_flag = 0;
	if((vis.atom_poly != m_prev_vis.atom_poly) || (vis.atom_radius != m_prev_vis.atom_radius)){
		//|Sf̏
		InitSphere( vis.atom_radius, vis.atom_poly, vis.atom_poly*2);
		redraw_flag = 1;
	}

	//q\F̃[hݒ//
	//m_visual_atomcolor = vis.atom_color;
	if(vis.atom_color != m_prev_vis.atom_color){
		redraw_flag = 1;
	}

	if((vis.bond_poly != m_prev_vis.bond_poly)||(vis.bond != m_prev_vis.bond)){
		//|Sf̏
		InitBond( vis.atom_radius * 0.25, vis.bond_poly);
		redraw_flag = 1;
	}

	if(dat != m_prev_render_dat){
		redraw_flag = 1;
	}

	
	
	//J[e[u
	if(redraw_flag){
		if(vis.atom_color ==  VISUAL_ATOMCOLOR_BONDNUM){
			//if(dat->bondInsideCnt == -1){
				CheckColorByBondNum2(dat, bond);
			//}else{
			//	CheckColorByBondNum(dat);
			//}
		}else if(vis.atom_color ==  VISUAL_ATOMCOLOR_PRESSURE){
			//if(dat->bondInsideCnt == -1){
				CheckColorByPressure(dat, bond);
			//}else{
			//	CheckColorByBondNum(dat);
			//}
		}else{	//MODE_COLOR_ATOMIC
			CheckColorByAtomKind(dat);
		}
	}

	//q̕`//
	if(vis.atom){
		const int count = dat->pcnt;
		if(vis.bond){redraw_flag = 1;}
		
		//_̌vZ//
		size_t num_draw_once = g_max_vram_size / (m_sphere_vcnt * sizeof(VERTEX_F3F3UI1) + m_sphere_icnt * sizeof(int));
		if(count > num_draw_once){//_̃obt@TCY𒴂ꍇ͕ɕĕ`悷//
			redraw_flag = 1;
		}

		size_t i_start = 0;
		while(i_start < count){

			if(i_start + num_draw_once > count){ num_draw_once = count - i_start;};

			
			if(redraw_flag){

				CreateSphere(i_start, num_draw_once, dat, bond);
			}
			

			if(m_vbo_icount){
	
				UpdateVertexBuffer(m_vbo_vertex, m_vbo_vcount, sizeof(VERTEX_F3F3UI1));	//_f[^VRAMɓ]
				UpdateIndexBuffer(m_vbo_indexes, m_vbo_icount, sizeof(int));	//CfbNXf[^VRAMɓ]
	
			//	Disable(DOG_BLEND);
				Draw(m_vbo_icount, NULL);
			}

			i_start += num_draw_once;
		}
			
	}

	
	//{h̕`//
	if(vis.bond){

		const int count = bond->count;

		if(vis.atom){redraw_flag = 1;}
		
		//_̌vZ//
		size_t num_draw_once = g_max_vram_size / (m_bond_vcnt * sizeof(VERTEX_F3F3UI1) + m_bond_icnt * sizeof(int));
		if(count > num_draw_once){//_̃obt@TCY𒴂ꍇ͕ɕĕ`悷//
			redraw_flag = 1;
		}

		size_t i_start = 0;
		while(i_start < count){

			if(i_start + num_draw_once > count){ num_draw_once = count - i_start;};

			
			if(redraw_flag){

				CreateBond(i_start, num_draw_once, dat, bond);
			}
			

			if(m_vbo_icount){
	
				UpdateVertexBuffer(m_vbo_vertex, m_vbo_vcount, sizeof(VERTEX_F3F3UI1));	//_f[^VRAMɓ]
				UpdateIndexBuffer(m_vbo_indexes, m_vbo_icount, sizeof(int));	//CfbNXf[^VRAMɓ]
	
			//	Disable(DOG_BLEND);
				Draw(m_vbo_icount, NULL);
			}

			i_start += num_draw_once;
		}
	}

	m_prev_render_dat = dat;
	m_prev_vis = vis;
}


void AtomRendererDX11::CreateSphere(int start, int count, ATOMS_DATA* dat, BOND_INFO* bond){

	//vboTCY
	int vbo_v_count = count * m_sphere_vcnt;
	int vbo_i_count = count * m_sphere_icnt;
	int need_vram_sz = vbo_v_count * sizeof(VERTEX_F3F3UI1) + vbo_i_count * sizeof(int);

	//ATOMS_DATA* dat = GetDataPointer();
	if(m_vram_size < need_vram_sz){
		m_vram_size = need_vram_sz;

		delete [] m_vbo_vertex;
		delete [] m_vbo_indexes;		
		m_vbo_vertex = new VERTEX_F3F3UI1[vbo_v_count];
		m_vbo_indexes = new int[vbo_i_count];
	}





	m_vbo_vcount = 0;
	m_vbo_icount = 0;
	
	//q()̃Zbg//
	const int i_end = start + count;
	for(int i = start; i < i_end; i++){
		if(m_color_table[i] & 0xFF000000){	//S߂͕\Ȃ//
			SetSphere(dat->r[i], m_color_table[i],
					m_vbo_vcount,	//_ԍoffset
					m_vbo_vertex + m_vbo_vcount,
					m_vbo_indexes + m_vbo_icount);

			m_vbo_vcount += m_sphere_vcnt;
			m_vbo_icount += m_sphere_icnt;
		}
	}


	
}


void AtomRendererDX11::CreateBond(int start, int count, ATOMS_DATA* dat, BOND_INFO* bond){

	
	//vboTCY
	int vbo_v_count = count * m_bond_vcnt;
	int vbo_i_count = count * m_bond_icnt;
	int need_vram_sz = vbo_v_count * sizeof(VERTEX_F3F3UI1) + vbo_i_count * sizeof(int);

	//ATOMS_DATA* dat = GetDataPointer();
	if(m_vram_size < need_vram_sz){
		m_vram_size = need_vram_sz;

		delete [] m_vbo_vertex;
		delete [] m_vbo_indexes;		
		m_vbo_vertex = new VERTEX_F3F3UI1[vbo_v_count];
		m_vbo_indexes = new int[vbo_i_count];
	}



	m_vbo_vcount = 0;
	m_vbo_icount = 0;
	

	//{h̃Zbg
	const VECTOR_IJ* b = bond->bvector;
	const int i_end = start + count;
	for (int i = start; i < i_end; i++){
		int li = b[i].i;
		int lj = b[i].j;
				
		if((m_color_table[li] & m_color_table[lj]) & 0xFF000000){	//S߂͕\Ȃ//
			
			SetBond2(dat->r[li], b[i].v, 
				m_color_table[li],
				m_color_table[lj],
				m_vbo_vcount,
				m_vbo_vertex + m_vbo_vcount,
				m_vbo_indexes + m_vbo_icount);
			
			m_vbo_vcount += m_bond_vcnt;
			m_vbo_icount += m_bond_icnt;
		}
	}
		
	
}


///////////////////////////////////////////////
//
//VBOɃ|SZbg@\
//
////////////////////////////////////////////////
	
void AtomRendererDX11::InitSphere(float radius, int slices, int stacks){
	int i, k;
	double daXY = 2.0*M_PI/double(stacks);
	double daZX = M_PI/double(slices);
	double angleZX;
	double angleXY;
	float cosZX, sinZX;
	float *cosXY, *sinXY;
	

	
	cosXY = new float[stacks];
	sinXY = new float[stacks];
	
	angleXY = daXY;
	cosXY[0] = 1.f;
	sinXY[0] = 0.f;
	for (i = 1; i < stacks; i++){
		cosXY[i] = (float)cos(angleXY);
		sinXY[i] = (float)sin(angleXY);
		angleXY += daXY;
	}

	m_sphere_vcnt = (slices - 1) * stacks + 2;
	delete [] m_sphere_pos;
	delete [] m_sphere_nor;
	vec3f *pos = m_sphere_pos = new vec3f[m_sphere_vcnt];
	vec3f *nor = m_sphere_nor = new vec3f[m_sphere_vcnt];


	nor->Set(0.0f, 0.0f, 1.0f);
	nor++;
	pos->Set(0.0f,0.0f,(float)radius);
	pos++;

	angleZX = daZX;
	for (i = 1; i < slices; i++){
		cosZX = (float)cos(angleZX);
		sinZX = (float)sin(angleZX);

		for (k = 0; k < stacks; k++){
			
			nor->Set(sinZX * cosXY[k], sinZX * sinXY[k], cosZX);
			pos->x = nor->x * radius;
			pos->y = nor->y * radius;
			pos->z = nor->z * radius;

			nor++;
			pos++;
		}
		angleZX += daZX;
	}
	
	nor->Set(0.0f, 0.0f, -1.0f);
	pos->Set(0.0f,0.0f, -radius);
	
	delete [] cosXY;
	delete [] sinXY;


	//CfbNXz̃Zbg
	m_sphere_icnt = (slices - 1)*stacks*6;
	delete [] m_sphere_idx;
	int* idx = m_sphere_idx = new int[m_sphere_icnt];
	int offset = 1;
	for(i=0; i < stacks; i++){
		*idx = 0;
		idx++;
		*idx = i + offset;
		idx++;
		*idx = ((i + 1) % stacks) + offset;
		idx++;
	}
	//offset += stacks;
	
	
	for (k = 0; k < slices - 2; k++){
		for(i=0; i < stacks; i++){
			*idx = i + offset;
			idx++;
			*(idx + 3) = *idx = i + offset + stacks;
			idx++;
			*(idx + 1) = *idx = ((i + 1) % stacks) + offset;
			idx+=3;
			*idx = ((i + 1) % stacks) + offset + stacks;
			idx++;
		}
		offset += stacks;
	}

	for(i=0; i < stacks; i++){
		*idx = i + offset;
		idx++;
		*idx = m_sphere_vcnt - 1;
		idx++;
		*idx = ((i + 1) % stacks) + offset;
		idx++;
	}
	
};

inline void AtomRendererDX11::SetSphere(vec3f& orgin, unsigned int onecolor, int index_offset, VERTEX_F3F3UI1* vtx, int* indexes){
	
	
	for(int i = 0; i < m_sphere_vcnt; i++){
		vtx[i].position = m_sphere_pos[i] + orgin;
		vtx[i].normal = m_sphere_nor[i];
		vtx[i].color = onecolor;
	}
	
	
	for(int i = 0; i < m_sphere_icnt; i++){
		indexes[i] = m_sphere_idx[i] + index_offset;
	}	

}



void AtomRendererDX11::InitBond(float radius, int stacks){
	int i, k;
	double daXY = 2.0*M_PI/double(stacks);
	double angleXY;
	float *cosXY, *sinXY;
	

	
	cosXY = new float[stacks];
	sinXY = new float[stacks];
	
	angleXY = daXY;
	cosXY[0] = 1.f;
	sinXY[0] = 0.f;
	for (i = 1; i < stacks; i++){
		cosXY[i] = (float)cos(angleXY);
		sinXY[i] = (float)sin(angleXY);
		angleXY += daXY;
	}

	m_bond_vcnt = stacks * 2;
	vec3f *pos = m_bond_pos = new vec3f[m_bond_vcnt];
	vec3f *nor = m_bond_nor = new vec3f[m_bond_vcnt];


	for (k = 0; k < stacks; k++){
			
		nor->Set(cosXY[k], sinXY[k], 0.f);
		pos->x = nor->x * radius;
		pos->y = nor->y * radius;
		pos->z = nor->z * radius;
		
		nor++;
		pos++;
		
	}

	memcpy(nor, m_bond_nor, sizeof(vec3f)*stacks);
	memcpy(pos, m_bond_pos, sizeof(vec3f)*stacks);

	for (k = 0; k < stacks; k++){
		pos->z += 1.f;
		pos++;
	}

	delete [] cosXY;
	delete [] sinXY;


	//CfbNXz̃Zbg
	m_bond_icnt = stacks * 6;
	int* idx = m_bond_idx = new int[m_bond_icnt];
	
	for(i=0; i < stacks; i++){
		*idx = i;
		idx++;
		*(idx + 3) = *idx = ((i + 1) % stacks);
		idx++;
		*(idx + 1) = *idx = i + stacks;
		idx+=3;
		*idx = ((i + 1) % stacks) + stacks;
		idx++;	
	}		
	
	
	
};


void AtomRendererDX11::InitCone(float radius, int stacks){
	int k;

	InitBond(radius, stacks);
	vec3f *pos = m_bond_pos;
	for (k = 0; k < stacks; k++){
			
		pos->x *= 3.f;
		pos->y *= 3.f;
		pos->z = ATOM_RADIUS;
		pos++;
		
	}

	for (k = 0; k < stacks; k++){
		pos->x = 0.f;
		pos->y = 0.f;
		pos->z -= ATOM_RADIUS;
		pos++;
	}

};



inline void AtomRendererDX11::SetBond2(const vec3f& v1, const vec3f& dv, unsigned int onecolor, unsigned int othercolor, int index_offset, VERTEX_F3F3UI1* vtx, int* indexes){
	
	

	vec3f ax;
	vec3f ay;
	ax.Set(dv.y, -dv.x, 0.0);
	float len = ax * ax;
	if(len < 0.00001){
		ax.Set(1.0f, 0.0f, 0.0f);
		ay.Set(0.0f, 1.0f, 0.0f);
	}else{
		ax /= sqrt(len);
		ay = Cross(dv, ax);
		len = ay*ay;
		ay /= sqrt(len);
	}
	
		
	for(int i = 0; i < m_bond_vcnt; i++){
		vtx[i].position = (ax * m_bond_pos[i].x) + (ay * m_bond_pos[i].y) + (dv * m_bond_pos[i].z) + v1;
		vtx[i].normal = ax * m_bond_nor[i].x + ay * m_bond_nor[i].y + dv * m_bond_nor[i].z;
	}
	

	//color̃Zbg	
	for(int i = 0; i < m_bond_vcnt / 2; i++){
		vtx[i].color = onecolor;
		
	}

	for(int i = 0; i < m_bond_vcnt / 2; i++){
		vtx[i].color = othercolor;
		
	}
		

	//CfbNX̃Zbg	
	for(int i = 0; i < m_bond_icnt; i++){
		indexes[i] = m_bond_idx[i] + index_offset;
	}
	
	
}

//qԍɃJ[vZ
void AtomRendererDX11::CheckColorByAtomKind( ATOMS_DATA* dat){
	
	//ATOMS_DATA* dat = GetDataPointer();

	delete [] m_color_table;
	m_color_table = new unsigned int[dat->pcnt];
	
	//FQ
	int i;
	for(i = 0; i < dat->pcnt; i++){
		m_color_table[i] = *(((unsigned int*)atom_colors) + dat->knd[i]);
	}
}


//{hɃJ[vZ
void AtomRendererDX11::CheckColorByBondNum2( ATOMS_DATA* dat, BOND_INFO* bond){
	
	//ATOMS_DATA* dat = GetDataPointer();

	delete [] m_color_table;
	m_color_table = new unsigned int[dat->pcnt];
	memset(m_color_table, 0, sizeof(unsigned int) * dat->pcnt);

	//bondvZ
	
	//FQ
	for(int i = 0; i < dat->pcnt; i++){
		if(bond->coords[i] >= COLOR_LIMIT_BOND){
			m_color_table[i] = *(((unsigned int*)bondnum_colors) + COLOR_LIMIT_BOND - 1);
		}else{
			m_color_table[i] = *(((unsigned int*)bondnum_colors) + bond->coords[i]);
		}
	}
}


//{hɃJ[vZ
void AtomRendererDX11::CheckColorByPressure( ATOMS_DATA* dat, BOND_INFO* bond){
	
	//ATOMS_DATA* dat = GetDataPointer();

	delete [] m_color_table;
	m_color_table = new unsigned int[dat->pcnt];
	memset(m_color_table, 0, sizeof(unsigned int) * dat->pcnt);

	//bondvZ
	
	//FQ
	for(int i = 0; i < dat->pcnt; i++){
		m_color_table[i] = bond->coords[i];
	}
}

void AtomRendererDX11::ClearVRAM(){
	m_prev_render_dat = NULL;

}
