//=====================================
// Dx9OpenGL1.5܂ł̊{_Os.
//
//
// 
//=====================================

#ifndef __BasicRenderer_h__
#define __BasicRenderer_h__


#pragma once

#define WIN32_LEAN_AND_MEAN             // Windows wb_[gpĂȂO܂B
#include <windows.h>

#include <stdio.h>
#include <tchar.h>
#include <string.h>
#include <math.h>


#include "sdkdx11.h"
#include "listTemplate.h"
#include "vec3.h"
#include "mat44.h"
#include "rowdog.h"

#include "debugprint.h"


#define SAFE_RELEASE(p) if(p){(p)->Release(); (p)=NULL;}


class BasicRenderer{
protected:

//DX11pO[oIuWFNg--------------------
	DX11_CORE* m_dx11_core;
	CommonShader* m_comShader;
	//CommonTexture* m_comTexture;

//DX11 shader---------------------------------------
	

	ID3D11VertexShader*     m_pVertexShader;
	ID3D11PixelShader*      m_pPixelShader;
	ID3D11InputLayout*      m_pVertexLayout;
	ID3D11Buffer*           m_pVertexBuffer;
	ID3D11Buffer*           m_pIndexBuffer;
	ID3D11BlendState*		m_pBlendState;

	UINT m_vertexBufSz;
	UINT m_indexBufSz;
	
	UINT			m_vertex_stride;
	DXGI_FORMAT		m_index_format;

	mat44f* m_pViewMatrix;
	mat44f* m_pProjectionMatrix;


	union {
		ID3D11Buffer* m_pConstantBuffers[2];
		struct {
			ID3D11Buffer*			m_pWVPBuffer;
			ID3D11Buffer*			m_pLightBuffer;
		};
	};


	//ގJ[ݒ=====================;
	float m_ambient_color[4];		//CgƂ̐F
	

	//BLENDݒ==========================;

	//void EnableFlagClear



public:
	
//	BasicRenderer(DX11_CORE* dx11_core, CommonShader* comShader, CommonTexture* comTexture, UINT vertexBufSz, UINT indexBufSz);
	BasicRenderer(DX11_CORE* dx11_core, CommonShader* comShader, UINT vertexBufSz, UINT indexBufSz);
	virtual ~BasicRenderer();

	//pɂă[hVF[_[t@C؂ւ.
	virtual HRESULT InitShader();	//X[p[NXł͌Ă΂Ȃ

	void UpdateVertexBuffer(LPVOID pBuffer, UINT count, UINT stride);
	void UpdateIndexBuffer(LPVOID pBuffer, UINT count, UINT stride);
	virtual void Draw(UINT index_count, vec3f* position);

	
	void SetViewMatrixPointer(mat44f* pViewMatrix );
	void SetProjectionMatrixPointer(mat44f* pProjectionMatrix );

//ȉAGL݊p============================================	
//	void Enable(unsigned int param);
//	void Disable(unsigned int param);

	void BlendFunc(D3D11_BLEND_DESC* pBlendDesc, unsigned int sfactor, unsigned int dfactor);

	void Materialfv(unsigned int face, unsigned int pname, float* rgba);
};

bool IsEqual(D3D11_BLEND_DESC a, D3D11_BLEND_DESC b);

//exeƓtH_ɂt@CpX֒.
int GetAttachedFileName(TCHAR* filepath, const TCHAR *filename);
///////////////////////////////////////////////////////////////////
//ϊspCu
///////////////////////////////////////////////////////////////////

//void SetViewMatrix(vec3f* target, vec3f* origin, vec3f* up, mat44f* pViewMatrix);
//void SetProjectionPerspectiveMatrix(float angle, float wph, float z_near, float z_far, mat44f* pProjectionMatrix);



#endif    // __BasicRenderer_h__

