
#include "Field3DLoader.h"
#include "bif_reader.h"

#pragma warning(disable : 4996)


Field3DLoader::Field3DLoader() : 
	m_frames(NULL),
	m_frame_count(0),
	m_frame_index(0)

{
	m_frames = new FIELD3D_FRAME[1000];
	

}


Field3DLoader::~Field3DLoader(){
	for(int i = 0; i < m_frame_count; i++){
		delete [] m_frames[i].fieldb;
	}
	delete [] m_frames;
	
}

int Field3DLoader::Load(const TCHAR* filename){

	size_t len = _tcslen(filename);
	if(_tcscmp(filename + len - 5, _T(".cube"))==0){ 
	
		float maxvalue;
		float* fieldf = LoadCube(filename, &maxvalue, &(m_frames[0]));
		//m_boxaxis.m11 = (double)m_grid_x * m_boxaxis.a.x;
		//m_boxaxis.m22 = (double)m_grid_y * m_boxaxis.b.y;
		//m_boxaxis.m33 = (double)m_grid_z * m_boxaxis.c.z;
		
		//BYTEJ[f[^֕ϊ//
		int mesh_sz = m_frames[0].grid_x*m_frames[0].grid_y*m_frames[0].grid_z;
		m_frames[0].fieldb = TransformToByteColor(fieldf, mesh_sz, maxvalue);

	
		delete [] fieldf;

		m_frame_count = 1;

	}else if (_tcscmp(filename + len - 4, _T(".bif"))==0){ 
		
		BIF_Reader* bif = new BIF_Reader();
		bif->Open(filename);

		field_int grid_x;
		field_int grid_y;
		field_int grid_z;
		double delta_x;
		double delta_y;
		double delta_z;
		double sz = 0;
		double* fieldd = NULL;

		int res = bif->GetSize(&grid_x, &grid_y, &grid_z, &delta_x, &delta_y, &delta_z);
		while (res > 0){
			int full_sz = (int)( grid_x * grid_y * grid_z);
			if( full_sz > sz){
				if( fieldd ){ delete []  fieldd;}
				fieldd = new double[full_sz];
				sz = full_sz;
			}
			bif->Read(fieldd);
			
	//		int mesh_sz = m_grid_x*m_grid_y*m_grid_z;
			const double MAX_VALUE = 1.0;
			m_frames[m_frame_count].fieldb = TransformToByteColor(fieldd, full_sz, MAX_VALUE);

			m_frames[m_frame_count].grid_x = (int)grid_x;
			m_frames[m_frame_count].grid_y = (int)grid_y;
			m_frames[m_frame_count].grid_z = (int)grid_z;
			m_frames[m_frame_count].boxaxis.Set(delta_x * (double)grid_x, 0.0, 0.0,  0.0, delta_y * (double)grid_y, 0.0,  0.0, 0.0, delta_z * (double)grid_z);
			m_frames[m_frame_count].boxorg.Clear();
			m_frame_count++;

			res = bif->GetSize(&grid_x, &grid_y, &grid_z, &delta_x, &delta_y, &delta_z);
		}

		bif->Close();
		delete bif;

		
		delete [] fieldd;
		
	}
	
	

	return 0;
	
}
	
float* Field3DLoader::LoadCube(const TCHAR* filename, float* pmaxvalue, FIELD3D_FRAME* frame){
	
	FILE* fp = _tfopen(filename, _T("r"));
	
		
	TCHAR line[1024];
	
	if(_fgetts(line, 1024, fp) == NULL){ fclose(fp);return NULL;}	//^Cg
	if(_fgetts(line, 1024, fp) == NULL){ fclose(fp);return NULL;}	//Rg

	if(_fgetts(line, 1024, fp) == NULL){ fclose(fp);return NULL;}	//qvolumef[^̌_W
	int pcnt;
	_stscanf(line,_T("%d %lf %lf %lf"), &pcnt, &(frame->boxorg.x), &(frame->boxorg.y), &(frame->boxorg.z));

	if(_fgetts(line, 1024, fp) == NULL){ fclose(fp);return NULL;}	//x̃bVx
	_stscanf(line,_T("%d %lf %lf %lf"), &(frame->grid_x), &(frame->boxaxis.a.x), &(frame->boxaxis.a.y), &(frame->boxaxis.a.z));

	if(_fgetts(line, 1024, fp) == NULL){ fclose(fp);return NULL;}	//ỹbVx
	_stscanf(line,_T("%d %lf %lf %lf"), &(frame->grid_y), &(frame->boxaxis.b.x), &(frame->boxaxis.b.y), &(frame->boxaxis.b.z));

	if(_fgetts(line, 1024, fp) == NULL){ fclose(fp);return NULL;}	//z̃bVx
	_stscanf(line,_T("%d %lf %lf %lf"), &(frame->grid_z), &(frame->boxaxis.c.x), &(frame->boxaxis.c.y), &(frame->boxaxis.c.z));

	int atomtype;
	vec3d posv3;
	for(int i = 0; i < pcnt; i++){
		if(_fgetts(line, 1024, fp) == NULL){ fclose(fp);return NULL;}	//qʒuǂݍ
		_stscanf(line,_T("%d %lf %lf %lf"), &atomtype, &(posv3.x), &(posv3.y), &(posv3.z));
	}
	
	//{[f[^̓ǂݍ
	int mesh_sz = (frame->grid_x) * (frame->grid_y) * (frame->grid_z);
	float* values = new float[mesh_sz];
	float* vp = values;
	TCHAR* tp;
	float maxvalue = 0.0;
	float minvalue = 1E10;
	while(_fgetts(line, 1024, fp) != NULL){
		tp = _tcstok(line, _T(" \t\r\n"));
		while(tp){
			*vp = (float)(_tcstod(tp, NULL));

			//ől̎擾
			if ( maxvalue < (*vp)){ maxvalue = *vp;}
			if ( minvalue > (*vp)){ minvalue = *vp;}

			tp = _tcstok(NULL, _T(" \t\r\n"));
			vp++;
		}
	}
	
	fclose(fp);

	maxvalue *= 1.0E-0;
	for(int i = 0; i  < mesh_sz; i++){
		values[i] = (values[i] - minvalue)/(maxvalue - minvalue);
	//	values[i] = sqrt(values[i]);
	}
	maxvalue = 1.0;

	frame->boxaxis.a *= (double)frame->grid_x;
	frame->boxaxis.b *= (double)frame->grid_y;
	frame->boxaxis.c *= (double)frame->grid_z;
	
	*pmaxvalue = maxvalue;
	return values;

}


template<typename T> GLubyte* Field3DLoader::TransformToByteColor(T* field, int mesh_sz, T maxvalue){

	//FeNX`̐.
	//maxvalue = ((T)1.0) / maxvalue;
	
	GLubyte* fieldb = new GLubyte[mesh_sz*4];
	GLubyte* tex = fieldb;
	
	for (int k = 0; k < mesh_sz; k++){
		
		SpectrumColor((T)(field[k])/maxvalue, tex, tex+1, tex+2);//Kiς//
		*(tex+3) = (BYTE)(96.0 * (T)(field[k])/maxvalue);//Kiς//
		
	//	valueToRGBA(field[k], maxvalue, tex);
	//	*(tex+3) = (BYTE)(96.0 * (T)(field[k])/maxvalue);//Kiς//
	//	if(*(tex+3) > 48){ *(tex+3) = 48;}
		

		
		if(*(tex+3) < 8){ *(tex+3) = 0;}
		//else{*(tex+3) = 16;}
	

		
		tex += 4;
	}
	return fieldb;

}



/**
* lƍőlFɕϊ
* @param value l
* @param maxValue l̍ől
* @param color l狁߂BGRAz
* by Naoki Kashima 
*/
void Field3DLoader::valueToRGBA(double value, double maxValue, unsigned char *rgb){
	static const int maxHue = 300;
	double f;
	int h;
	int i, p, q, t;
	double opacity;

	if (value < 0)value = 0;
	if (value > maxValue)value = maxValue;
	h = (int) (maxHue * value / maxValue);

	i = (int) floor(h / 60.0) % 6;
	//i = (h * 6)/maxHue;
	f = (double) (h / 60.0) - (double) floor(h / 60.0);
	p = 0;
	q = (int) (255 * (1.0 - f) + 0.5);
	t = (int) (255 * f + 0.5);

	switch (i){
	case 0:
	opacity = (double) h / 60.0;
	//opacity = 255;
	//rgb[0] = 255; rgb[1] = t; rgb[2] = p; rgb[3] = (unsigned char)opacity;
	rgb[2] = (unsigned char) (255 * opacity); rgb[1] = (unsigned char) (t * opacity); rgb[0]
	= (unsigned char) (p * opacity); rgb[3] = (unsigned char) (255 * opacity);
	break;
	case 1: rgb[2] = q; rgb[1] = 255; rgb[0] = p; rgb[3] = 255; break;
	case 2: rgb[2] = p; rgb[1] = 255; rgb[0] = t; rgb[3] = 255; break;
	case 3: rgb[2] = p; rgb[1] = q; rgb[0] = 255; rgb[3] = 255; break;
	case 4: rgb[2] = t; rgb[1] = p; rgb[0] = 255; rgb[3] = 255; break;
	case 5: rgb[2] = 255; rgb[1] = p; rgb[0] = q; rgb[3] = 255; break;
	}
}

//XyNgFԂ
void Field3DLoader::SpectrumColor(double value, BYTE *r, BYTE* g, BYTE * b){
//	static BYTE tr[11] = {0, 12, 90,160,200,225,240,250,250,250,250};
//	static BYTE tg[11] = {0,  0,  0,  0,  0, 40, 90,140,190,240,250};
//	static BYTE tb[11] = {0,120,150,150,120, 10,  0,  0, 10,120,250};
	static BYTE tr[11] = {0, 38, 76,  0,  0,  0,  0, 60,120,180,255};
	static BYTE tg[11] = {0,  0,  0,  0,140,180,250,180,120, 60,  0};
	static BYTE tb[11] = {0,106,211,230,120, 60,  0,  0,  0,  0,  0};

	if(value < 0.0){
		*r = *g = *b = 0;
	}

	double pos;
	double tt = modf(value * 10.0, &pos);
	int ipos = (int)(pos);
	if(ipos >= 10){
		*r = tr[10];
		*g = tg[10];
		*b = tb[10];
	}else if(ipos <0){
		*r = tr[0];
		*g = tg[0];
		*b = tb[0];
	}else{
		*r = tr[ipos] + (BYTE)(tt * (tr[ipos+1]-tr[ipos]));
		*g = tg[ipos] + (BYTE)(tt * (tg[ipos+1]-tg[ipos]));
		*b = tb[ipos] + (BYTE)(tt * (tb[ipos+1]-tb[ipos]));
	}

}


int Field3DLoader::SetFrameNum(int timeframe){

	int newFrameNo = timeframe;

	if(newFrameNo >= m_frame_index){

		if(newFrameNo >= m_frame_count){ newFrameNo = m_frame_count-1;}

	}else{
		if(newFrameNo < 0){ newFrameNo = 0;}

	}


	m_frame_index = newFrameNo;
	return m_frame_index;

}