
/*
{hXg.
obt@ȂƂ-1Ԃ
*/
template <class TBVECTOR>
int LCL::CreateBondList(int start_index, int count, const vec3d* r, double CUTOFF_SQR, TBVECTOR* bvector, BVEC_REGION* bvecStartEnd, int buf_sz_bond){
	// local variable ------------------------------;

#pragma omp parallel
{

	LCL_INFO info;
	vec3d periodic_vec[27];
	this->GetCellInfo(&info, periodic_vec);
	
	const int cell_wx = info.cell_x;
	const int cell_wy = info.cell_y;
	const int cell_wz = info.cell_z;
	const int* icell = info.icell;
	const int* first_in_cell = info.first_in_cell;
	const int* inext = info.inext;
	
	const int cell_wxwy = cell_wx * cell_wy;
	const int cell_wxwywz = cell_wxwy * cell_wz;



#ifdef _OPENMP
	// shift array pointer for each thread //
	const int th = omp_get_thread_num();
	const int thread_count = omp_get_num_threads();
	int bond_index = th * (buf_sz_bond/thread_count) + 1;
#else
	const int th = 0;
	const int thread_count = 1;
	int bond_index = 1;
#endif


	//int max_num = 0;
	
	//openmp parallelization for atoms//

	const int end_index = start_index + count;
	
	#pragma omp for
	for(int i = start_index; i < end_index; i++){
		const vec3d r_i = r[i];
		const int ic = icell[i];
		//const int ki = m_knd[i];
		const int start_point = bond_index;


		const int icell_z = ic / cell_wxwy;
		int nz[3] = {0, 0, 0};
		int tz[3] = {-cell_wxwy, 0, cell_wxwy};
		
		if(icell_z == 0){
			nz[0] = 18;	//2 * (3 * 3)
			tz[0] += cell_wxwywz;
		}
		if (icell_z == cell_wz - 1){
			nz[2] = 9;	//1 * (3 * 3)
			tz[2] -= cell_wxwywz;
		}

		const int icell_y = (ic / cell_wx) % cell_wy;
		int ny[3] = {0, 0, 0};
		int ty[3] = {-cell_wx, 0, cell_wx};
		if(icell_y == 0){
			ny[0] = 6;	//2 * 3
			ty[0] += cell_wxwy;
		}
		if (icell_y == cell_wy - 1){
			ny[2] = 3;	//1 * 3
			ty[2] -= cell_wxwy;
		}

		const int icell_x = ic % cell_wx;
		int nx[3] = {0, 0, 0};
		int tx[3] = {-1, 0, 1};
		if(icell_x == 0){
			nx[0] = 2;
			tx[0] = (cell_wx - 1);
		}
		if (icell_x == cell_wx - 1){
			nx[2] = 1;
			tx[2] = (1 - cell_wx);
		}

		// loop for adjoin cell and same cell//
		//int num_t = 0;
		for(int iz = 0; iz < 3; iz++){
			for(int iy = 0; iy < 3; iy++){
				for(int ix= 0; ix < 3; ix++){

					const int nxyz = nx[ix] + ny[iy] + nz[iz];
					const int target_cell = ic + tx[ix] + ty[iy] + tz[iz];
					
					//if(target_cell == ic) continue;
					
					//if(nxyz){//قȂZ//(PperiodicEׂȂɂȂĂ܂Ă)
					//if(target_cell != ic){//قȂZ//(unit cell̍ۂɂׂĂZɂȂĂ܂)
					if(((ix & (iy & iz)) & 0x1) == 0){//(unit cellł)
					
					
						const vec3d rb_i = r_i - *(periodic_vec + nxyz);
						for (int j = first_in_cell[target_cell]; j != -1; j = inext[j]){
							const vec3d dd = rb_i - r[j];

							const double r2 = dd * dd;

							// judge the relative distance //
							if (r2 <= CUTOFF_SQR) {
		
								// add to bonding array //
								TBVECTOR& bv_i = bvector[bond_index];

								bv_i.pairIndex = j;
								bv_i.rij = dd;
								bv_i.dr = sqrt(r2);
		
								// increment of index //
								bond_index ++;
							}
						}
						
					
					}else{//Z//
						const vec3d rb_i = r_i;
						for (int j = first_in_cell[target_cell]; j != -1; j = inext[j]){
							if(i == j){
								//x܂ł13/27ZƓZ̑OI//
								bvecStartEnd[i].twobodyendpoint = bond_index;	//end point for two-body force of i-th particle's bond//
							}else{
								const vec3d dd = rb_i - r[j];
								const double r2 = dd * dd;

								// judge the relative distance //
								if (r2 <= CUTOFF_SQR) {
		
									// add to bonding array //
									TBVECTOR& bv_i = bvector[bond_index];

									bv_i.pairIndex = j;
									bv_i.rij = dd;
									bv_i.dr = sqrt(r2);
		
									// increment of index //
									bond_index ++;
								}
							}
						}
					}
		

				}
			}
		}//iz//


		bvecStartEnd[i].startpoint = start_point;	//start point of i-th particle's bond array//
		bvecStartEnd[i].endpoint = bond_index;	//end point of i-th particle's bond//

	}//end of for i//

#ifdef _DEBUG
	bond_index = bond_index;
#endif

}//end of omp parallel//

/*
	//check of bond buffer size//
	{
		const int limit_sz = (th+1) * (buf_sz_bond/thread_count) + 1;
		if(bond_index >= limit_sz){
			return -1;
		}
	}
*/

	return 0;

};



/*
{hXg.
obt@ȂƂ-1Ԃ
*/
template <typename TBVECTOR>
int GetBondList(LCL* pLCL, int i, const vec3d* r, double CUTOFF_SQR, TBVECTOR* bvector, int* half_point){
	// local variable ------------------------------;


	int num_bonds = 0;
	int twobody_endpoint = 0;

	LCL_INFO info;
	//vec3d periodic_vec[27];
	//pLCL->GetCellInfo(&info, periodic_vec);
	const vec3d* periodic_vec = pLCL->GetCellInfo(&info);
	
	const int cell_wx = info.cell_x;
	const int cell_wy = info.cell_y;
	const int cell_wz = info.cell_z;
	const int* icell = info.icell;
	const int* first_in_cell = info.first_in_cell;
	const int* inext = info.inext;
	
	const int cell_wxwy = cell_wx * cell_wy;
	const int cell_wxwywz = cell_wxwy * cell_wz;



	{
		const vec3d r_i = r[i];
		const int ic = icell[i];
		//const int ki = m_knd[i];

	//	worker.Begin(i);
	//	const int start_point = bond_index;


		const int icell_z = ic / cell_wxwy;
		int nz[3] = {0, 0, 0};
		int tz[3] = {-cell_wxwy, 0, cell_wxwy};
		
		if(icell_z == 0){
			nz[0] = 18;	//2 * (3 * 3)
			tz[0] += cell_wxwywz;
		}
		if (icell_z == cell_wz - 1){
			nz[2] = 9;	//1 * (3 * 3)
			tz[2] -= cell_wxwywz;
		}

		const int icell_y = (ic / cell_wx) % cell_wy;
		int ny[3] = {0, 0, 0};
		int ty[3] = {-cell_wx, 0, cell_wx};
		if(icell_y == 0){
			ny[0] = 6;	//2 * 3
			ty[0] += cell_wxwy;
		}
		if (icell_y == cell_wy - 1){
			ny[2] = 3;	//1 * 3
			ty[2] -= cell_wxwy;
		}

		const int icell_x = ic % cell_wx;
		int nx[3] = {0, 0, 0};
		int tx[3] = {-1, 0, 1};
		if(icell_x == 0){
			nx[0] = 2;
			tx[0] = (cell_wx - 1);
		}
		if (icell_x == cell_wx - 1){
			nx[2] = 1;
			tx[2] = (1 - cell_wx);
		}

		// loop for adjoin cell and same cell//
		//int num_t = 0;
		for(int iz = 0; iz < 3; iz++){
			for(int iy = 0; iy < 3; iy++){
				for(int ix= 0; ix < 3; ix++){

					const int nxyz = nx[ix] + ny[iy] + nz[iz];
					const int target_cell = ic + tx[ix] + ty[iy] + tz[iz];
					
					//if(target_cell == ic) continue;
					
					//if(nxyz){//قȂZ//(PperiodicEׂȂɂȂĂ܂Ă)
					//if(target_cell != ic){//قȂZ//(unit cell̍ۂɂׂĂZɂȂĂ܂)
					if(((ix & (iy & iz)) & 0x1) == 0){//(unit cellł)
					
					
						const vec3d rb_i = r_i - *(periodic_vec + nxyz);
						for (int j = first_in_cell[target_cell]; j != -1; j = inext[j]){
							const vec3d dd = rb_i - r[j];

							const double r2 = dd * dd;

							// judge the relative distance //
							if (r2 <= CUTOFF_SQR) {
		
								//worker.Work(i, j, dd, r2);
								
								// add to bonding array //
								TBVECTOR& bv_i = bvector[num_bonds];

								bv_i.pairIndex = j;
								bv_i.rij = dd;
								bv_i.dr = sqrt(r2);
		
								// increment of index //
								num_bonds ++;
								
							}
						}
						
					
					}else{//Z//
						const vec3d rb_i = r_i;
						for (int j = first_in_cell[target_cell]; j != -1; j = inext[j]){
							if(i == j){
								//x܂ł13/27ZƓZ̑OI//
								twobody_endpoint = num_bonds;	//end point for two-body force of i-th particle's bond//
								//worker.Intermidiate();

							}else{

								const vec3d dd = rb_i - r[j];
								const double r2 = dd * dd;

								// judge the relative distance //
								if (r2 <= CUTOFF_SQR) {
									
									//worker.Work(i, j, dd, r2);
									
									// add to bonding array //
									TBVECTOR& bv_i = bvector[num_bonds];

									bv_i.pairIndex = j;
									bv_i.rij = dd;
									bv_i.dr = sqrt(r2);
		
									// increment of index //
									num_bonds ++;
									
								}
							}
						}
					}
		

				}
			}
		}//iz//

//		worker.End();
//		bvecStartEnd[i].startpoint = start_point;	//start point of i-th particle's bond array//
//		bvecStartEnd[i].endpoint = bond_index;	//end point of i-th particle's bond//

		*half_point = twobody_endpoint;


	}//end of for i//

	




	return num_bonds;


};




/*
{hXg.
obt@ȂƂ-1Ԃ
*/
template <class WORKER>
int LoopBondList(LCL* pLCL, int start_index, int count, const vec3d* r, double CUTOFF_SQR, WORKER worker){
	// local variable ------------------------------;

//#pragma omp parallel
{

	LCL_INFO info;
	vec3d periodic_vec[27];
	pLCL->GetCellInfo(&info, periodic_vec);
	
	const int cell_wx = info.cell_x;
	const int cell_wy = info.cell_y;
	const int cell_wz = info.cell_z;
	const int* icell = info.icell;
	const int* first_in_cell = info.first_in_cell;
	const int* inext = info.inext;
	
	const int cell_wxwy = cell_wx * cell_wy;
	const int cell_wxwywz = cell_wxwy * cell_wz;


	//int max_num = 0;
	
	//openmp parallelization for atoms//

	const int end_index = start_index + count;
	
	#pragma omp for
	for(int i = start_index; i < end_index; i++){
		const vec3d r_i = r[i];
		const int ic = icell[i];
		//const int ki = m_knd[i];

		worker.Begin(i);
	//	const int start_point = bond_index;


		const int icell_z = ic / cell_wxwy;
		int nz[3] = {0, 0, 0};
		int tz[3] = {-cell_wxwy, 0, cell_wxwy};
		
		if(icell_z == 0){
			nz[0] = 18;	//2 * (3 * 3)
			tz[0] += cell_wxwywz;
		}
		if (icell_z == cell_wz - 1){
			nz[2] = 9;	//1 * (3 * 3)
			tz[2] -= cell_wxwywz;
		}

		const int icell_y = (ic / cell_wx) % cell_wy;
		int ny[3] = {0, 0, 0};
		int ty[3] = {-cell_wx, 0, cell_wx};
		if(icell_y == 0){
			ny[0] = 6;	//2 * 3
			ty[0] += cell_wxwy;
		}
		if (icell_y == cell_wy - 1){
			ny[2] = 3;	//1 * 3
			ty[2] -= cell_wxwy;
		}

		const int icell_x = ic % cell_wx;
		int nx[3] = {0, 0, 0};
		int tx[3] = {-1, 0, 1};
		if(icell_x == 0){
			nx[0] = 2;
			tx[0] = (cell_wx - 1);
		}
		if (icell_x == cell_wx - 1){
			nx[2] = 1;
			tx[2] = (1 - cell_wx);
		}

		// loop for adjoin cell and same cell//
		//int num_t = 0;
		for(int iz = 0; iz < 3; iz++){
			for(int iy = 0; iy < 3; iy++){
				for(int ix= 0; ix < 3; ix++){

					const int nxyz = nx[ix] + ny[iy] + nz[iz];
					const int target_cell = ic + tx[ix] + ty[iy] + tz[iz];
					
					//if(target_cell == ic) continue;
					
					//if(nxyz){//قȂZ//(PperiodicEׂȂɂȂĂ܂Ă)
					//if(target_cell != ic){//قȂZ//(unit cell̍ۂɂׂĂZɂȂĂ܂)
					if(((ix & (iy & iz)) & 0x1) == 0){//(unit cellł)
					
					
						const vec3d rb_i = r_i - *(periodic_vec + nxyz);
						for (int j = first_in_cell[target_cell]; j != -1; j = inext[j]){
							const vec3d dd = rb_i - r[j];

							const double r2 = dd * dd;

							// judge the relative distance //
							if (r2 <= CUTOFF_SQR) {
		
								worker.Work(i, j, dd, r2);
								/*
								// add to bonding array //
								TBVECTOR& bv_i = bvector[bond_index];

								bv_i.pairIndex = j;
								bv_i.rij = dd;
								bv_i.dr = sqrt(r2);
		
								// increment of index //
								bond_index ++;
								*/
							}
						}
						
					
					}else{//Z//
						const vec3d rb_i = r_i;
						for (int j = first_in_cell[target_cell]; j != -1; j = inext[j]){
							if(i == j){
								//x܂ł13/27ZƓZ̑OI//
								//bvecStartEnd[i].twobodyendpoint = bond_index;	//end point for two-body force of i-th particle's bond//
								worker.Intermidiate();

							}else{

								const vec3d dd = rb_i - r[j];
								const double r2 = dd * dd;

								// judge the relative distance //
								if (r2 <= CUTOFF_SQR) {
									
									worker.Work(i, j, dd, r2);
									/*
									// add to bonding array //
									TBVECTOR& bv_i = bvector[bond_index];

									bv_i.pairIndex = j;
									bv_i.rij = dd;
									bv_i.dr = sqrt(r2);
		
									// increment of index //
									bond_index ++;
									*/
								}
							}
						}
					}
		

				}
			}
		}//iz//

		worker.End(i);
//		bvecStartEnd[i].startpoint = start_point;	//start point of i-th particle's bond array//
//		bvecStartEnd[i].endpoint = bond_index;	//end point of i-th particle's bond//

	}//end of for i//



}//end of omp parallel//



	return 0;

};


template <class TBVECTOR>
class WORKER_ADD_BOND{
private:
	int m_bond_index;
	TBVECTOR* m_bvector;
	BVEC_REGION* m_bvecStartEnd;

	int m_start_point;
	int m_twobodyendpoint;

public:
	WORKER_ADD_BOND(TBVECTOR* bvector, BVEC_REGION* bvecStartEnd, int bond_index) : 
		m_bvector(bvector), m_bvecStartEnd(bvecStartEnd), m_bond_index(buf_sz_bond)
	{
		
	};

	~WORKER_ADD_BOND(){};

	void Begin(int i){
		//m_bond_index = m_bond_par_atom * i;
		m_start_point = m_bond_index;

	};

	void Work(int i, int j, const vec3d& dd, const double r2) {
			// add to bonding array //
		TBVECTOR& bv_i = m_bvector[m_bond_index];

		bv_i.pairIndex = j;
		bv_i.rij = dd;
		bv_i.dr = sqrt(r2);
		
		// increment of index //
		m_bond_index ++;
	};

	void Intermidiate(){
		m_twobodyendpoint = m_bond_index;	//end point for two-body force of i-th particle's bond//
	}

	void End(int i){

		m_bvecStartEnd[i].twobodyendpoint = m_twobodyendpoint;
		m_bvecStartEnd[i].startpoint = m_start_point;	//start point of i-th particle's bond array//
		m_bvecStartEnd[i].endpoint = m_bond_index;	//end point of i-th particle's bond//

	};

};