// MDLoader.cpp: MDLoader NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////
#pragma warning(disable : 4996)

#include "MDLoader.h"

#include "md3_reader.h"
#include "mbsdup.h"
#include "io64.h"
#include "renew.h"

#include <string.h>
#include <math.h>




extern mat33f g_default_boxaxis;


static const int TXT_INITIAL_ATOM = 4096;
//static const int TXT_INITIAL_BOND = 8192;

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

MDLoader::MDLoader(const TCHAR *filename) :
	//m_bond_check(0),
	m_fa2(NULL),
	m_fad(NULL),
	m_frameNo(0)
{
	
	m_maxAtomCount = 0;
	m_maxBondCount = 0;


	Load(filename);
	if(!m_framev.empty()){
		m_framev[0].keep = 1;
	}


}


MDLoader::~MDLoader(){
	
	if(m_fad){ delete [] m_fad;}
	
	if(m_fa2){ delete [] m_fa2;}
	
	clearBuffer();

}



void MDLoader::Load(const TCHAR *filename){


	size_t outlen = _tcslen(filename);
	
	if(_tcscmp(filename + outlen - 4,_T(".fad")) == 0){
	
		
		if(FirstLoadFAD(filename) < 0){
			printf( "t@C̃I[vɎs܂ : %s\n",filename);	
			readMode = -1;
			return;  // ُI͂OȊOԂ
		}
		readMode = 2;
	
	}else if( _tcscmp(filename + outlen - 4,_T(".fa2")) == 0){

		
		if(FirstLoadFA2(filename) < 0){
			printf( "t@C̃I[vɎs܂ : %s\n",filename);	
			readMode = -1;
			return;  // ُI͂OȊOԂ
		}
		readMode = 4;
	
	}else if(_tcscmp(filename + outlen - 4, _T(".pdb")) == 0){
		//eLXg`̂Ƃ
		//64rbgł͓ǂ܂ȂB

		FILE* fp32 = _tfopen(filename,_T("r"));
		if( fp32 == NULL ){  // ֐sĂȂ
			printf( "t@C̃I[vɎs܂ : %s\n",filename);	
			readMode = -1;
			return;  // ُI͂OȊOԂ
		}
	
		int mcnt = FirstLoadTXT(fp32, 3);
	//	m_fpos_current = m_fpos_first;
		fclose(fp32);
		readMode = 0;
		return;
	}else if((_tcscmp(filename + outlen - 4,_T(".xyz"))==0)||(_tcscmp(filename + outlen - 3,_T(".md")) == 0)){

		FILE* fp32 = _tfopen(filename,_T("r"));
		if( fp32 == NULL ){  // ֐sĂȂ
			printf( "t@C̃I[vɎs܂ : %s\n",filename);	
			readMode = -1;
			return;  // ُI͂OȊOԂ
		}
	
		int mcnt = FirstLoadTXT(fp32, 4);
	//	m_fpos_current = m_fpos_first;
		fclose(fp32);
		readMode = 0;
		return;
	
	}else if( _tcscmp(filename + outlen - 4,_T(".md2")) == 0){

		FILE* fp32 = _tfopen(filename,_T("r"));
		if( fp32 == NULL ){  // ֐sĂȂ
			printf( "t@C̃I[vɎs܂ : %s\n",filename);	
			readMode = -1;
			return;  // ُI͂OȊOԂ
		}
	
		int mcnt = FirstLoadTXT(fp32, 5);
	//	m_fpos_current = m_fpos_first;
		fclose(fp32);
		readMode = 0;
		return;
	
	}else if( _tcscmp(filename + outlen - 4,_T(".md3")) == 0){

		
		if(FirstLoadMD3(filename) < 0){
			printf( "t@C̃I[vɎs܂ : %s\n",filename);	
			readMode = -1;
			return;  // ُI͂OȊOԂ
		}
	
		readMode = 0;
		return;
	}

	
}

int MDLoader::FirstLoadFA2(const TCHAR* filepath){

	
	FA2_Reader* fa2 = new FA2_Reader();
	{

		char* mbfpath = MbsDup(filepath);
		int ierr = fa2->Open(mbfpath);
		delete [] mbfpath;
		if( ierr != 0){
			printf("error: file cannot be opened\n");
			delete fa2;
			return -2;
		}

	}

	m_fa2 = fa2;
	m_unknown_pos = 0LL;

	int frame = 0;
	FRAME_POS framepos;
	int count = ReadFrameFA2(&framepos);
	
	while(count){
		framepos.filepos = m_unknown_pos;
		framepos.atmdat->frame = frame;
		framepos.atmdat->istep = frame;
		framepos.atmdat->no = frame;
		m_framev.push_back(framepos);
	
		m_unknown_pos = m_fa2->GetFilePointer();
			
		count = ReadFrameFA2(&framepos);
		frame++;

		if(m_unknown_pos > READLIMIT) break;

	}	

	if(count == 0){
		m_unknown_pos = 0LL;
	}

	return 0;
}
	
int MDLoader::ReadFrameFA2(FRAME_POS* framepos){

	framepos->atmdat = NULL;
	framepos->keep =0;

	if(m_fa2 == NULL){
		return 0;
	}
		
	long long fpos = m_fa2->GetFilePointer();
	int count = m_fa2->GetParticleCount();
	if(count == 0){
		return 0;
	}
		
	//obt@m//
	ATOMS_DATA *a = new ATOMS_DATA;
	a->pcnt = count;
	a->knd = new int[count];
	a->id = new int[count];
	a->r = new vec3f[count];
	a->p = new vec3f[count];
		

	//t@Cǂݍ//////////////////////////////////
	m_fa2->ReadF(a->knd, a->id, (float*)(a->r), (float*)(a->p), (float*)&(a->boxaxis));
		
	framepos->filepos = fpos;
	framepos->atmdat = a;
	
	return count;
	
}




int MDLoader::FirstLoadFAD(const TCHAR* filepath){

	
	FAD_Reader* fad = new FAD_Reader();
	{
		char* mbfpath = MbsDup(filepath);
		int ierr = fad->Open(mbfpath);
		delete [] mbfpath;
		if( ierr != 0){
			printf("error: file cannot be opened\n");
			delete fad;
			return -2;
		}

	}

	m_fad = fad;
	m_unknown_pos = 0LL;

	int frame = 0;
	FRAME_POS framepos;
	int count = ReadFrameFAD(&framepos);
	
	while(count){
		framepos.filepos = m_unknown_pos;
		framepos.atmdat->frame = frame;
		framepos.atmdat->istep = frame;
		framepos.atmdat->no = frame;
		m_framev.push_back(framepos);
			
		m_unknown_pos = m_fad->GetFilePointer();

		count = ReadFrameFAD(&framepos);
		frame++;

		if(m_unknown_pos > READLIMIT) break;
	}

	if(count == 0){
		m_unknown_pos = 0LL;
	}
	
	return 0;
}
	
int MDLoader::ReadFrameFAD(FRAME_POS* framepos){

	framepos->atmdat = NULL;
	framepos->keep =0;

	if(m_fad == NULL){
		return 0;
	}
		

	int count = m_fad->GetParticleCount();
	if(count == 0){
		return 0;
	}
		
	//obt@m//
	ATOMS_DATA *a = new ATOMS_DATA;
	a->pcnt = count;
	a->knd = new int[count];
	a->id = new int[count];
	a->r = new vec3f[count];
	a->p = NULL;
		

	//t@Cǂݍ//////////////////////////////////
	m_fad->ReadF(a->knd, a->id, (float*)(a->r), NULL, (float*)&(a->boxaxis));
		

	framepos->atmdat = a;
	
	
	
	return count;
	
}




int MDLoader::FirstLoadTXT(FILE *fp, int mode){

	ATOMS_DATA *a;
	ATOMS_DATA *readBuf= new ATOMS_DATA;

	int mcnt;
		
	mcnt = 0;

	readMode = 0;

	
	readBuf->pcnt = TXT_INITIAL_ATOM;



	readBuf->knd = new int[TXT_INITIAL_ATOM];
	readBuf->r = new vec3f[TXT_INITIAL_ATOM];

	readBuf->no = 1;
	readBuf->info = NULL;
	
	switch(mode){
	case 3:
		a = readFramePDB(fp,readBuf);
		break;
	case 4:
		a = readFrameXYZ(fp,readBuf);
		break;
	case 5:
		a = readFrameMD2(fp,readBuf);
		break;
	default:
		return 0;
	}

	while(a){
		

		if(a->no == -1){ a->no = mcnt;}
		FRAME_POS framepos;
		framepos.filepos = 0;
		framepos.atmdat = a;
		framepos.keep = 0;
		m_framev.push_back(framepos);


		mcnt ++;
		readBuf->no++;


		switch(mode){
		case 3:
			a = readFramePDB(fp,readBuf);
			break;
		case 4:
			a = readFrameXYZ(fp,readBuf);
			break;
		case 5:
			a = readFrameMD2(fp,readBuf);
			break;
		}

	}

	if (m_unknown_pos) {
		//rf
		printf("buffer fulls halfway\n");
	}

	


	printf("%d frame loaded\n",mcnt);
	
	return mcnt;
	
}


int MDLoader::FirstLoadMD3(const TCHAR* filepath){


	readMode = 0;


	

	MD3_Reader* md3 = new MD3_Reader();
	{

		char* mbfpath = MbsDup(filepath);
		int ierr = md3->Open(mbfpath);
		delete [] mbfpath;
		if( ierr != 0){
			printf("error: file cannot be opened\n");
			delete md3;
			return -2;
		}

	}
	
	int count = md3->GetParticleCount();
	int frame = 0;
	vec3d* atoms_r = NULL;
	int bufsize = 0;
	double boxaxisorg[12];

	while(count > 0){
		
		//obt@m//
		ATOMS_DATA *a = new ATOMS_DATA;
		a->pcnt = count;
		a->knd = new int[count];
		a->id = new int[count];
		a->r = new vec3f[count];

		//doubleobt@m//
		if(count > bufsize){
			delete [] atoms_r;
		
			bufsize = count;
			atoms_r = new vec3d[count];
		}

		//t@Cǂݍ//////////////////////////////////
		int res = md3->Read(a->knd, (double*)atoms_r, NULL, NULL, boxaxisorg, NULL);
		if(res != count){
			printf("%d frame error: %d particles were read.\n", frame, res);
			delete a;
			break;
		}

		/////////////////////////////////t@Cǂݍ//

		//cast double to float//
		for(int i = 0; i < count; i++){
			a->r[i] = atoms_r[i];
			a->id[i] = i;
		}

		for(int i = 0; i < 9; i++){
			a->boxaxis.elements[i] = (float)boxaxisorg[i];
		}
		a->boxorg.Clear();


		a->id = NULL;
		a->frame = frame;
		a->istep = frame;
		a->no = frame;

		a->p = NULL;
		
		FRAME_POS framepos;
		framepos.filepos = 0;
		framepos.atmdat = a;
		framepos.keep = 0;
		m_framev.push_back(framepos);

		frame++;

		count = md3->GetParticleCount();

	}

	md3->Close();
	delete md3;
	delete [] atoms_r;
		
	printf("%d frame loaded\n",frame);
	
	return frame;
	
}



ATOMS_DATA* MDLoader::readFramePDB(FILE* fp, ATOMS_DATA* readBuf){
	
	char chbuf[256];
	char kndch[256];
	char line[256];

//	int dmyi;
	int pcnt,bcnt;
//	float rr,Jmax;
//	vec3f dr;
	const float bondmax[] = {2.0f*2.0f, 1.8f*1.8f, 1.7f*1.7f};//{1.85*1.85, 1.55*1.55, 1.4*1.4};
	
	int istep;
	short int* pkindint; 

	
	int* knd = readBuf->knd;

	vec3f* r = readBuf->r;



	int flag_J;	//0: energy currentL, 1: 
	
	ATOMS_DATA *a;



//	Jmax = -1.0;
	if(fgets(line,255,fp) == NULL){ return NULL;}
	if (strncmp(line,"MODEL",5) != 0){ return NULL;}

		sscanf(line,"%s %d",chbuf, &istep);
			flag_J = 0x8;

		pcnt = 0;
		bcnt=0;
		

		while (fgets(line,255,fp) != NULL){
			if(strncmp(line,"ENDMDL",6) == 0){break;}
			if(strncmp(line,"ATOM",4) == 0){
				sscanf(line,"%s%s%s%s %f %f %f",chbuf,chbuf,kndch,chbuf,
					&(r[pcnt].x), &(r[pcnt].y), &(r[pcnt].z));

				pkindint = (short int*)kndch;
				if (strcmp(kndch,"Cc") == 0){	//C_custom
					knd[pcnt] = 0;
				//}else if (strcmp(kndch,"H")==0){
				}else if (*pkindint == 72){
					knd[pcnt] = 1;
				}else if (strcmp(kndch,"He")==0){
					knd[pcnt] = 2;
				}else if (strcmp(kndch,"Li")==0){
					knd[pcnt] = 3;
				}else if (strcmp(kndch,"Be")==0){
					knd[pcnt] = 4;
				}else if (strcmp(kndch,"B")==0){
					knd[pcnt] = 5;
				}else if (strcmp(kndch,"C")==0){
					knd[pcnt] = 6;
				}else if (strcmp(kndch,"N")==0){
					knd[pcnt] = 7;
				}else if (strcmp(kndch,"O")==0){
					knd[pcnt] = 8;
				}else if (strcmp(kndch,"F")==0){
					knd[pcnt] = 9;
				}else if (strcmp(kndch,"N")==0){
					knd[pcnt] = 10;
				}else if (strcmp(kndch,"Na")==0){
					knd[pcnt] = 11;
				}else if (strcmp(kndch,"Mg")==0){
					knd[pcnt] = 12;
				}else if (strcmp(kndch,"Al")==0){
					knd[pcnt] = 13;
				}else if (strcmp(kndch,"Si")==0){
					knd[pcnt] = 14;
				}else if (strcmp(kndch,"P")==0){
					knd[pcnt] = 15;
				}else if (strcmp(kndch,"S")==0){
					knd[pcnt] = 16;
				}else if (strcmp(kndch,"Cl")==0){
					knd[pcnt] = 17;
				}else if (strcmp(kndch,"Ar")==0){
					knd[pcnt] = 18;
				}else if (strcmp(kndch,"K")==0){
					knd[pcnt] = 19;
				}else if (strcmp(kndch,"Ca")==0){
					knd[pcnt] = 20;
				}else{
					knd[pcnt] = 21;
				}

				pcnt ++ ;
				//obt@I[o[t[
				if (pcnt == readBuf->pcnt){
					
					readBuf->pcnt *= 4;
					
					renew(&knd, pcnt, readBuf->pcnt);
					renew((float**)&r, pcnt*3, readBuf->pcnt*3);
					
					readBuf->knd = knd;
					readBuf->r = r;
				}

			}
			
		}
		


		//AI_atomdatɃRs[
		a = new ATOMS_DATA;
		
		a->pcnt=pcnt;
//		a->bcnt=bcnt;
		a->boxaxis.Clear();
		a->boxorg.Clear();
		a->tempave = 0.0f;
		a->tempvar = 0.0f;
		a->no = readBuf->no;
		a->istep = istep;
		a->realtm = 0.0;
		
		a->knd = new int[pcnt];
		memcpy(a->knd, knd, sizeof(char) * pcnt);
		a->r = new vec3f[pcnt];
		memcpy(a->r, r, sizeof(vec3f) * pcnt);

		a->info = NULL;

		if(m_maxAtomCount < pcnt){ m_maxAtomCount = pcnt;}
		if(m_maxBondCount < bcnt){ m_maxBondCount = bcnt;}

	return a;


}



ATOMS_DATA* MDLoader::readFrameXYZ(FILE* fp, ATOMS_DATA* readBuf){
	
	char kndch[256];
	char line[1024];

	int pcnt,bcnt;
	float Jmax;
	const float BOND_LENGTH_SQUARE = 2.0f*2.0f;
	

	
	int* knd = NULL;
	vec3f* r = NULL;
//	float* Jij = readBuf->Jij;
	short int* pkindint; 

	
	ATOMS_DATA *a;



	Jmax = -1.0;
	if(fgets(line,1024,fp) == NULL){ return NULL;}
		sscanf(line,"%d", &pcnt);
		if(pcnt<=0){return NULL;}
		bcnt=0;

		
		if(fgets(line,1024,fp) == NULL){ return NULL;}
		//epictureƂtitle̓ǂݎ

		a = new ATOMS_DATA;
		a->knd = knd = new int[pcnt];
		a->r = r = new vec3f[pcnt];
		a->pcnt = pcnt;
		pcnt = 0;
		
		a->info = _strdup(line);

		while (fgets(line,1024,fp) != NULL){
			sscanf(line,"%s %f %f %f",kndch, &(r[pcnt].x), &(r[pcnt].y), &(r[pcnt].z));
			
			pkindint = (short int*)kndch;
			switch (*pkindint){
			case 0x6343:
			case 0x4343:
				knd[pcnt] = 0;
				break;
			case 'H':
			case 'h':
				knd[pcnt] = 1;
				break;
			case 0x6548:
			case 0x6568:
				knd[pcnt] = 2;
				break;
			case 0x694C:
			case 0x696C:
				knd[pcnt] = 3;
				break;
			case 0x6542:
			case 0x6562:
				knd[pcnt] = 4;
				break;
			case 'B':
			case 'b':
				knd[pcnt] = 5;
				break;
			case 'C':
			case 'c':
				knd[pcnt] = 6;
				break;
			case 'N':
			case 'n':
				knd[pcnt] = 7;
				break;
			case 'O':
			case 'o':
				knd[pcnt] = 8;
				break;
			case 'F':
			case 'f':
				knd[pcnt] = 9;
				break;
			case 0x654E:
			case 0x656E:
				knd[pcnt] = 10;
				break;
			case 0x614E:
			case 0x616E:
				knd[pcnt] = 11;
				break;
			case 0x674D:
			case 0x676D:
				knd[pcnt] = 12;
				break;
			case 0x6c41:
			case 0x6c61:
				knd[pcnt] = 13;
				break;
			case 0x6953:
			case 0x6973:
				knd[pcnt] = 14;
				break;
			case 'P':
			case 'p':
				knd[pcnt] = 15;
				break;
			case 'S':
			case 's':
				knd[pcnt] = 16;
				break;
			case 0x6C43:
			case 0x6C63:
				knd[pcnt] = 17;
				break;
			case 0x7241:
			case 0x7261:
				knd[pcnt] = 18;
				break;
			case 'k':
			case 'K':
				knd[pcnt] = 19;
				break;
			case 0x6145:
			case 0x6165:
				knd[pcnt] = 17;
				break;
			default:
				knd[pcnt] = 0;
			}
		
				pcnt ++ ;
				//obt@I[o[t[
				if (pcnt == a->pcnt){break;}
		}


		//AI_atomdatɃRs[		
//		a->bcnt=bcnt;
		a->boxaxis = g_default_boxaxis;
		a->boxorg.Clear();
		a->tempave = 0.0f;
		a->tempvar = 0.0f;
		a->no = readBuf->no;
		a->istep = 0;
		a->realtm = 0.0;
		

		if(m_maxAtomCount < pcnt){ m_maxAtomCount = pcnt;}
		if(m_maxBondCount < bcnt){ m_maxBondCount = bcnt;}

	return a;


}


ATOMS_DATA* MDLoader::readFrameMD2(FILE* fp, ATOMS_DATA* readBuf){
	
	char kndch[256];
	char line[1024];

	int pcnt,bcnt;
	float Jmax;
	const float BOND_LENGTH_SQUARE = 2.0f*2.0f;
	

	
	int* knd = NULL;
	vec3f* r = NULL;
//	float* Jij = readBuf->Jij;
	short int* pkindint; 

	
	ATOMS_DATA *a;



	Jmax = -1.0;
	if(fgets(line,1024,fp) == NULL){ return NULL;}
		sscanf(line,"%d", &pcnt);
		if(pcnt<=0){return NULL;}
		bcnt=0;

		
		if(fgets(line,1024,fp) == NULL){ return NULL;}
		//epictureƂtitle̓ǂݎ

		a = new ATOMS_DATA;
		a->knd = knd = new int[pcnt];
		a->r = r = new vec3f[pcnt];
		a->pcnt = pcnt;
		pcnt = 0;
		
		a->info = _strdup(line);

		while (fgets(line,1024,fp) != NULL){
			int id = 0;
			sscanf(line,"%d %s %f %f %f", &id, kndch, &(r[pcnt].x), &(r[pcnt].y), &(r[pcnt].z));
			
			pkindint = (short int*)kndch;
			switch (*pkindint){
			case 0x6343:
			case 0x4343:
				knd[pcnt] = 0;
				break;
			case 'H':
			case 'h':
				knd[pcnt] = 1;
				break;
			case 0x6548:
			case 0x6568:
				knd[pcnt] = 2;
				break;
			case 0x694C:
			case 0x696C:
				knd[pcnt] = 3;
				break;
			case 0x6542:
			case 0x6562:
				knd[pcnt] = 4;
				break;
			case 'B':
			case 'b':
				knd[pcnt] = 5;
				break;
			case 'C':
			case 'c':
				knd[pcnt] = 6;
				break;
			case 'N':
			case 'n':
				knd[pcnt] = 7;
				break;
			case 'O':
			case 'o':
				knd[pcnt] = 8;
				break;
			case 'F':
			case 'f':
				knd[pcnt] = 9;
				break;
			case 0x654E:
			case 0x656E:
				knd[pcnt] = 10;
				break;
			case 0x614E:
			case 0x616E:
				knd[pcnt] = 11;
				break;
			case 0x674D:
			case 0x676D:
				knd[pcnt] = 12;
				break;
			case 0x6c41:
			case 0x6c61:
				knd[pcnt] = 13;
				break;
			case 0x6953:
			case 0x6973:
				knd[pcnt] = 14;
				break;
			case 'P':
			case 'p':
				knd[pcnt] = 15;
				break;
			case 'S':
			case 's':
				knd[pcnt] = 16;
				break;
			case 0x6C43:
			case 0x6C63:
				knd[pcnt] = 17;
				break;
			case 0x7241:
			case 0x7261:
				knd[pcnt] = 18;
				break;
			case 'k':
			case 'K':
				knd[pcnt] = 19;
				break;
			case 0x6145:
			case 0x6165:
				knd[pcnt] = 17;
				break;
/*			case 'w':
			case 'W':
				knd[pcnt] = 74;
				break;*/
			default:
				knd[pcnt] = 0;
			}
		
				pcnt ++ ;
				//obt@I[o[t[
				if (pcnt == a->pcnt){break;}
		}


		//AI_atomdatɃRs[		
//		a->bcnt=bcnt;
		a->boxaxis = g_default_boxaxis;
		a->boxorg.Clear();
		a->tempave = 0.0f;
		a->tempvar = 0.0f;
		a->no = readBuf->no;
		a->istep = 0;
		a->realtm = 0.0;
		


		if(m_maxAtomCount < pcnt){ m_maxAtomCount = pcnt;}
		if(m_maxBondCount < bcnt){ m_maxBondCount = bcnt;}

	return a;


}



void MDLoader::clearBuffer(){
	
	
	for( IT_FRAME_POS it = m_framev.begin(); it != m_framev.end(); it++){
		if (it->atmdat){
			DeleteFrame(it->atmdat);
			it->atmdat = NULL;
		}
	}
	//delete m_framev;
}


int MDLoader::goNext(){
	//1Ԃ


	if (readMode == -1){ return 0;}

	

	if(m_frameNo + 1 < (int)m_framev.size() ){
		//݂Aǂݍݍς݂ł
		m_frameNo++;
		return 1;
	}
	
	if(m_unknown_pos == LONG64_ZERO){
		//t@CI[
		return 0;
	}

	//Ǖ̓ǂݍ//
	int count = 0;
	FRAME_POS framepos;
			
	const long long current_pos = m_unknown_pos;
	switch (readMode){
	case 2:
		m_fad->SetFilePointer(m_unknown_pos);
		count = ReadFrameFAD(&framepos);
		if(count > 0){
			m_unknown_pos = m_fad->GetFilePointer();
		}else{
			m_unknown_pos = 0;
			return 0;
		}
		break;
	case 4:
		m_fa2->SetFilePointer(m_unknown_pos);
		count = ReadFrameFA2(&framepos);
		if(count > 0){
			m_unknown_pos = m_fa2->GetFilePointer();
		}else{
			m_unknown_pos = 0;
			return 0;
		}
		break;
	case 0:
		return 0;
	}
	
	{
		
		m_frameNo++;
		framepos.filepos = current_pos;
		framepos.atmdat->frame = m_frameNo;
		framepos.atmdat->istep = m_frameNo;
		framepos.atmdat->no = m_frameNo;
		m_framev.push_back(framepos);
	}
	
	//buffer̈ڍs
	UnloadStock();

	//m_frameNo++;
	return 1;
	
}


int MDLoader::goNext(int num){
	

	if(num<=0){return -1;}
	if (readMode == -1){ return 0;}

	for(int i=0;i<num - 1;i++){
		
		if(m_frameNo + 1 < (int)m_framev.size() ){
			//݂
			m_frameNo++;
			
		}else{
			
			if(m_unknown_pos == LONG64_ZERO){
				//t@CI[
				return 0;
			}

			const long long current_pos = m_unknown_pos;
			switch (readMode){
			case 2:
				{
					m_fad->SetFilePointer(current_pos);
					int count = m_fad->GetParticleCount();
					if(count > 0){
						m_fad->SkipFrame();
						m_unknown_pos = m_fad->GetFilePointer();
					}else{
						m_unknown_pos = LONG64_ZERO;
						return 0;
					}
				}
				break;
			case 4:
				{
					m_fa2->SetFilePointer(current_pos);
					int count = m_fa2->GetParticleCount();
					if(count > 0){
						m_fa2->SkipFrame();
						m_unknown_pos = m_fa2->GetFilePointer();
					}else{
						m_unknown_pos = LONG64_ZERO;
						return 0;
					}
				}
				break;
			case 0:
				return 0;
			}
				
			
			//if (count > 0)//
			{
		
				FRAME_POS framepos;
				framepos.keep = 0;
				framepos.atmdat = NULL;
				framepos.filepos = current_pos;
				m_framev.push_back(framepos);
			}
					
			m_frameNo++;
		}
	}
	
	
	return goNext();
}

int MDLoader::goPrev(){
	if (readMode == -1){ return 0;}

	if(m_frameNo > 0){
		m_frameNo--;
		return 1;
	}
	return 0;
}


int MDLoader::goPrev(int num){

	if(num<=0){return -1;}
	if (readMode == -1){ return 0;}

	if(m_frameNo == 0){return 0;}
	m_frameNo-=num;
	if(m_frameNo < 0){
		m_frameNo = 0;
	}
	return 1;
}

void MDLoader::goFirst(){
	if (readMode == -1){ return;}
	
	m_frameNo = 0;
	
}

ATOMS_DATA* MDLoader::GetDataPointer(){
	if (readMode == -1){ return NULL;}

	if(m_framev[m_frameNo].atmdat == NULL){
		if(readMode>0){
			switch (readMode){
			case 2:
	
				m_fad->SetFilePointer(m_framev[m_frameNo].filepos);
				ReadFrameFAD(&(m_framev[m_frameNo]));
				break;
			case 4:
				
				m_fa2->SetFilePointer(m_framev[m_frameNo].filepos);
				ReadFrameFA2(&(m_framev[m_frameNo]));
				break;
			}
			


			if(m_framev[m_frameNo].atmdat){
				//ǂ߂Ƃ({IɕKǂ߂邱ƂۏႳĂ͂)
				UnloadStock();
			}
		}
	}


	return m_framev[m_frameNo].atmdat;
	
}

void MDLoader::KeepCurrentFrame(){
	m_framev[m_frameNo].keep = 1;

}



int MDLoader::GetFrameNum(){
	return m_frameNo;
}

int MDLoader::SetFrameNum(int frameNo){
//w肵t[܂ŃWv.
//Ãt[̃f[^݂Ȃꍇɂ.
//݂̑ŏIt[܂ŃWvĎ~܂.
//߂lɂ͎ۂɈړt[NoÂ,
//ɂăt@C̍ŏIt[ɒBfł.

	int delta = frameNo - m_frameNo;
	if(delta > 0){
		goNext(delta);
	}else if(delta < 0){
		goPrev(-delta);
	}

	
	return m_frameNo;

}

void MDLoader::DeleteFrame(ATOMS_DATA *dat){
	
	if (dat){
		delete dat;
	}
}


void MDLoader::UnloadStock(){
	int i = 0;
	for (IT_FRAME_POS it = m_framev.begin(); it != m_framev.end(); it++){
		if( i != m_frameNo){
			if(it->atmdat){
				if(it->keep == 0){
					DeleteFrame(it->atmdat);
					it->atmdat = NULL;
					break;
				}
				
			}
		}
		i++;
	}
}

