
#ifndef MDLoader_h
#define MDLoader_h

#pragma once


#include "BOND_INFO.h"

#include "io64.h"
#include "mod.h"

#include "fa2_reader.h"
#include "fad_reader.h"


#include "ATOMS_DATA.h"

#include <cstdio>
#include <cstdint>
#include <vector>
using namespace std;



const long64 READLIMIT = 16*1024*1024;	// 64M


#define KIND_ALL (255)
#define MDL_FLAG_READBOND	 (1)





class MDLoader{
private:

	struct FRAME_POS{
		long64 filepos;
		ATOMS_DATA* atmdat;
		int keep;
	};

typedef vector<FRAME_POS>	V_FRAME_POS;
typedef vector<FRAME_POS>::iterator	IT_FRAME_POS;

	V_FRAME_POS m_framev;	//LbV//

	FA2_Reader* m_fa2;
	FAD_Reader* m_fad;


	long64 m_unknown_pos;		//܂ǂݍ݂ĂȂt@Cpos. I[ĂȂLONG64_ZERO.
	//FILEPOS_LIST->next==NULL ̂Ƃ
	//	unknown_pos == LONG64_ZERO Ȃ, t@C
	//	unknown_pos != LONG64_ZERO Ȃ, ǂݍ݂
	//		ǂݍݎsȂ, t@CƂunknown_posLONG64_ZEROZbg
	//		ǂݍݐȂ, t@Cł͂Ȃ̂, Xgt, , unknown_posɐVt@C|C^Zbg.


	int readMode;//0: obt@łȂt@C`, 2: fad`, 4: fa2`
	int m_frameNo;			//݂̓̃t[io[


	
	int m_maxAtomCount;
	int m_maxBondCount;
	

	


	int FirstLoadTXT(FILE *fp, int mode);
	ATOMS_DATA* readFramePDB(FILE* fp, ATOMS_DATA* readBuf);
	ATOMS_DATA* readFrameXYZ(FILE* fp, ATOMS_DATA* readBuf);
	ATOMS_DATA* readFrameMD2(FILE* fp, ATOMS_DATA* readBuf);

	int FirstLoadMD3(const TCHAR* filepath);
	

	int FirstLoadFAD(const TCHAR* filepath);
	int ReadFrameFAD(FRAME_POS* framepos);
	
	int FirstLoadFA2(const TCHAR* filepath);
	int ReadFrameFA2(FRAME_POS* framepos);

	void clearBuffer();
	void DeleteFrame(ATOMS_DATA *dat);
	
	void Load(const TCHAR *filename);
	void UnloadStock();
	void KeepCurrentFrame();


	int goPrev();
	int goPrev(int num);
	


public:
	
	MDLoader(const TCHAR *filename);
	virtual ~MDLoader();
	int goNext();
	int goNext(int num);
	void goFirst();
	ATOMS_DATA* GetDataPointer();



	int GetFrameNum();
	int SetFrameNum(int frameNo);
	

	

};





#endif // !MDLoader_h

