
#define  _CRT_SECURE_NO_WARNINGS

#include "RenderGL15.h"

#include "camera.h"
#include "filelist.h"
#include "setting.h"

#include "windib2.h"

#define WIN32_LEAN_AND_MEAN             // Windows wb_[gpĂȂO܂B
#include <windows.h>
#include <tchar.h>


extern double VIEW_ANGLE;
extern double VIEW_NEAR;
extern double VIEW_FAR;



//GLŕ`悵erbg}bv摜Ƃĕۑ//
void OutputBMfromGLMag(VP_FileList& files, const TCHAR *fName, int width, int height, int magnify, CameraGL* cam){
	
	FILE* fp = _tfopen(fName,_T("wb"));
	if (!fp){
		printf("bmpt@C̍쐬Ɏs܂\n");
		return;
	}
	

	
	glPixelStorei( GL_PACK_ALIGNMENT, 4);
	//f[^]4byteɃZbgB32bitƂ̂B//
	//]ȕ0Ŗ߂BDIBdlȂ̂ł傤Ǘǂ//
	
	//If using double buffer, select source to read pixels.
	//By default, mode is GL_FRONT in single-buffered configurations,
	//and GL_BACK in double-buffered configurations.
	glReadBuffer(GL_BACK);

	
	int size_Color = 3;	
	int line_size = width * size_Color;
	if (line_size % 4){	line_size += 4 - (line_size % 4);}
	BYTE *bmBuf = new BYTE[line_size * height];

	int all_line_size = width * size_Color * magnify;
	if (all_line_size % 4){	all_line_size += 4 - (all_line_size % 4);}
	BYTE *allBuf = new BYTE[all_line_size * height * magnify];
	
	glLineWidth((float)magnify);

	
	int offset_y = 0;

	for (int y = 0; y < magnify; y++){
		int offset_x = 0;
		for (int x = 0; x < magnify; x++){


			RenderingGL15_2(files, width * magnify, height * magnify, width * x, height * y, width, height, cam, g_visual_projection);

			glViewport(0, 0, width, height);

			glReadPixels(0, 0, width, height,  // ǂݎTCY
				GL_BGR,             // ǂݎ`ݒ(verႢƓȂ)
				GL_UNSIGNED_BYTE,                  // ۑ̃|C^̌^ 
				bmBuf                 // ۑ̔z̃|C^
			);

			for(int k = 0; k < height; k++){
				memcpy(allBuf + offset_y + offset_x + k * all_line_size,
						bmBuf + k * line_size, 	width * size_Color);
			}
					
			offset_x += width * size_Color;

		}
		offset_y += all_line_size * height;

	}

	delete [] bmBuf;
	
	writeDIB24(fp, width * magnify, height * magnify, allBuf);
	
	delete [] allBuf;
	fclose(fp);

	glLineWidth(1.0f);

}


#if 0

void OutputRaytracing(FileInfo* fi, const TCHAR *fName, int width, int height, int magnify, CameraGL* cam){


	const int screen_w = width * magnify;
	const int screen_h = height * magnify;


	int nx, ny, nz;
	fi->field->GetGridSize(&nx, &ny, &nz);
	mat33d axis;
	vec3d org;
	fi->field->GetBoxaxis(&axis, &org);
				
	GLubyte* buf = fi->field->GetDataPointer();


	vec3d r, tgt, up;
	cam->GetInfo(&tgt, &r, &up);
	vec3d v0 = tgt - r;
	double distance = std::sqrt(v0*v0);
	vec3d vr = Cross(v0, up);
	vr = Unit(vr);

	double top = distance * tan(VIEW_ANGLE);
	double right = top * (double)screen_w / (double)screen_h;
				
	up *= top;
	vr *= right;

	v0 -= up + vr;

	up *= 1.0 / (double)screen_h * 2.0;
	vr *= 1.0 / (double)screen_w * 2.0;


	vec3d eea = axis.a / (axis.a * axis.a);
	vec3d eec = axis.c / (axis.c * axis.c);

				
	int size_Color = 3;	
	int line_size = screen_w * size_Color;
	if (line_size % 4){	line_size += 4 - (line_size % 4);}
	BYTE *bmBuf = new BYTE[line_size * screen_h];


	for(int sy = 0; sy < screen_h; sy++){

		BYTE* wBuf = bmBuf + line_size * sy;

		for(int sx = 0; sx < screen_w; sx++){

			vec3d v = v0 + up * ((double)sy) + vr * ((double)sx);


			wBuf[0] = 0;
			wBuf[1] = 0;
			wBuf[2] = 0;
			//wBuf[3] = 0;

			BYTE maxalpha = 7;

			const int iorg_end = ny;
			for(int iorg = 0; iorg < iorg_end; iorg++){
							
				vec3d ro = r + (axis.b / (double)iorg_end);
				double t = -ro.y / v.y;

				vec3d p = ro + v * t;

				double dx = p * eea;
				double dz = p * eec;

				int ix = (int)(dx * (double)nx);
				int iz = (int)(dz * (double)nz);

				//ix = sx;
				//iz = sy;

				if(ix >= 0){
				if(ix < nx){
				if(iz >= 0){
				if(iz < nz){


					int index = ix + nx * (iorg  + ny * iz);
					index *= 4;

					if(buf[index + 3] > maxalpha){
									
						wBuf[0] = buf[index + 2];
						wBuf[1] = buf[index + 1];
						wBuf[2] = buf[index + 0];
						//wBuf[3] = buf[index + 3];
						
						maxalpha = buf[index + 3];
						
						
					}


				}}}}

			}//for end iorg//

			wBuf += 3;

		}
	}


	FILE* fp = _tfopen(fName, _T("wb"));
	writeDIB24(fp, screen_w, screen_h, bmBuf);
	fclose(fp);
	delete [] bmBuf;


}


#else

/*
_rxNgv֐Lт钼
_ʂ@nʂƂ̌_(r+t*v)vZ
߂ltԂ
*/
double GetCrossPoint(const vec3d& r, const vec3d& v, const vec3d& n){
	return -(r*n) / (v*n);

}



/*
LƂ͕ʂ̕@Ŏ
*/
void OutputRaytracing(FileInfo* fi, const TCHAR *fName, int width, int height, int magnify, CameraGL* cam){


	const int screen_w = width * magnify;
	const int screen_h = height * magnify;


	int nx, ny, nz;
	fi->field->GetGridSize(&nx, &ny, &nz);
	mat33d axis;
	vec3d org;
	fi->field->GetBoxaxis(&axis, &org);
				
	GLubyte* buf = fi->field->GetDataPointer();


	vec3d r, tgt, up;
	cam->GetInfo(&tgt, &r, &up);
	vec3d v0 = tgt - r;
	double distance = std::sqrt(v0*v0);
	vec3d vr = Cross(v0, up);
	vr = Unit(vr);

	double top = distance * tan(VIEW_ANGLE);
	double right = top * (double)screen_w / (double)screen_h;
				
	up *= top;
	vr *= right;

	v0 -= up + vr;

	up *= 1.0 / (double)screen_h * 2.0;
	vr *= 1.0 / (double)screen_w * 2.0;


	vec3d eea = axis.a / (axis.a * axis.a);
	vec3d eeb = axis.b / (axis.b * axis.b);
	vec3d eec = axis.c / (axis.c * axis.c);

				
	int size_Color = 3;	
	int line_size = screen_w * size_Color;
	if (line_size % 4){	line_size += 4 - (line_size % 4);}
	BYTE *bmBuf = new BYTE[line_size * screen_h];


	for(int sy = 0; sy < screen_h; sy++){

		BYTE* wBuf = bmBuf + line_size * sy;

		for(int sx = 0; sx < screen_w; sx++){

			//XN[ʏ̃sNZ(sx,sy)ɊւvZ//


			wBuf[0] = 0;
			wBuf[1] = 0;
			wBuf[2] = 0;
			//wBuf[3] = 0;

			BYTE maxalpha = 7;

			
			//XN[ʏ̃sNZ(sx,sy)ʉ߂3Ԓ̃xNg//
			vec3d v = v0 + up * ((double)sy) + vr * ((double)sx);

			
			//xNgvƃV~[V{bNX6̖ʂƂ̌_߂B//
			//{bNXтȂʂ2͂//

			double cross_point[6];
			int num_cross = 0;


			//x-yʂƂ̌//
			{
				double t = GetCrossPoint(r, v, axis.c);
				vec3d p = r + v * t;
			
				double dx = p * eea;
				double dy = p * eeb;
			
				if(dx >= 0.0){
				if(dx < 1.0){
				if(dy >= 0.0){
				if(dy < 1.0){
					cross_point[num_cross] = t;
					num_cross++;
				}}}}
			}

			//x-y()Ƃ̌//
			{
				double t = GetCrossPoint(r - axis.c, v, axis.c);
				vec3d p = (r-axis.c) + v * t;
			
				double dx = p * eea;
				double dy = p * eeb;
			
				if(dx >= 0.0){
				if(dx < 1.0){
				if(dy >= 0.0){
				if(dy < 1.0){
					cross_point[num_cross] = t;
					num_cross++;
				}}}}
			}
			
			
			//y-zʂƂ̌//
			{
				double t = GetCrossPoint(r, v, axis.a);
				vec3d p = r + v * t;
			
				double dx = p * eeb;
				double dy = p * eec;
			
				if(dx >= 0.0){
				if(dx < 1.0){
				if(dy >= 0.0){
				if(dy < 1.0){
					cross_point[num_cross] = t;
					num_cross++;
				}}}}
			}

			//y-z()Ƃ̌//
			{
				double t = GetCrossPoint(r - axis.a, v, axis.a);
				vec3d p = (r-axis.a) + v * t;
			
				double dx = p * eeb;
				double dy = p * eec;
			
				if(dx >= 0.0){
				if(dx < 1.0){
				if(dy >= 0.0){
				if(dy < 1.0){
					cross_point[num_cross] = t;
					num_cross++;
				}}}}
			}

			
			//z-xʂƂ̌//
			{
				double t = GetCrossPoint(r, v, axis.b);
				vec3d p = r + v * t;
			
				double dx = p * eec;
				double dy = p * eea;
			
				if(dx >= 0.0){
				if(dx < 1.0){
				if(dy >= 0.0){
				if(dy < 1.0){
					cross_point[num_cross] = t;
					num_cross++;
				}}}}
			}

			//z-x()Ƃ̌//
			{
				double t = GetCrossPoint(r - axis.b, v, axis.b);
				vec3d p = (r-axis.b) + v * t;
			
				double dx = p * eec;
				double dy = p * eea;
			
				if(dx >= 0.0){
				if(dx < 1.0){
				if(dy >= 0.0){
				if(dy < 1.0){
					cross_point[num_cross] = t;
					num_cross++;
				}}}}
			}


			//̃f[^̓ǂݍ//
			if (num_cross == 2){

				double t1, t2;
				if(cross_point[0] < cross_point[1]){
					t1 = cross_point[0];
					t2 = cross_point[1];
				}else{
					t1 = cross_point[1];
					t2 = cross_point[0];
				}

				if(t1 < VIEW_NEAR){ t1 = VIEW_NEAR;}
				if(t2 > VIEW_FAR){ t2 = VIEW_FAR;}
				
				const double dt = distance / 64.0;
				
				//s֒T//
				for(double t = t1; t < t2; t+=dt){

					vec3d p = r + v * t;

					double dx = p * eea;
					double dy = p * eeb;
					double dz = p * eec;

					
					int ix = (int)(dx * (double)nx);
					int iy = (int)(dy * (double)ny);
					int iz = (int)(dz * (double)nz);

					
					int index = ix + nx * (iy + ny * iz);
					index *= 4;

					if(buf[index + 3] > maxalpha){
									
						wBuf[0] = buf[index + 2];
						wBuf[1] = buf[index + 1];
						wBuf[2] = buf[index + 0];
						//wBuf[3] = buf[index + 3];
						
						maxalpha = buf[index + 3];
						
					}
				}

			}


			wBuf += 3;

		}
	}


	FILE* fp = _tfopen(fName, _T("wb"));
	writeDIB24(fp, screen_w, screen_h, bmBuf);
	fclose(fp);
	delete [] bmBuf;


}

#endif