// PointRendererDX11.cpp: PointRendererDX11 NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "PointRendererDX11.h"

#include "atomic_color.h"

#define _USE_MATH_DEFINES
#include <math.h>

#include <string.h>

extern size_t g_max_vram_size;



PointRendererDX11::PointRendererDX11(DX11_CORE* dx11_core, CommonShader* comShader) : 
		BasicRenderer(dx11_core, comShader, 0,0),
		m_texturepath(NULL),
	//DXnIuWFNgϐNULLZbg.
		m_pGeometryShader(NULL),
		//m_pTextureRV(NULL),
		m_pSampler(NULL), 
		m_pDepthStencilState(NULL),
	m_vram_size( 0 ),
	m_prev_render_dat( NULL ),
	m_vbo_vertex( NULL ),
	m_color_table( NULL )	
{
	
	memset(&m_prev_vis, 0, sizeof(VISUAL_SETTING));
	
	m_pPointSize.x = 0.5f;
	m_pPointSize.y = 0.5f;

	InitShader();

}


PointRendererDX11::~PointRendererDX11(){

	delete [] m_vbo_vertex;
	
	delete [] m_color_table;
	if(m_texturepath){ delete [] m_texturepath;}

    SAFE_RELEASE( m_pSampler );
	SAFE_RELEASE(m_pDepthStencilState );
	
    //SAFE_RELEASE(m_pTextureRV );
//	if( m_pTextureRV ) m_comTexture->UnloadTexture(m_pTextureRV);
	
	if( m_pGeometryShader ) m_comShader->UnloadShader((LPVOID)m_pGeometryShader);

}



HRESULT PointRendererDX11::InitShader(){
	TCHAR filepath[MAX_PATH];
	//GetAttachedFileName(filepath, _T("resource\\PointSpriteRenderer.sh"));

	//Vertex Shader--------------------------------------
    // Define the input layout
    D3D11_INPUT_ELEMENT_DESC layout[] =
    {
        { "POSITION", 0, DXGI_FORMAT_R32G32B32_FLOAT, 0, 0, D3D11_INPUT_PER_VERTEX_DATA, 0 },
		{ "COLOR", 0, DXGI_FORMAT_R8G8B8A8_UNORM, 0, 12, D3D11_INPUT_PER_VERTEX_DATA, 0 },

    };
	UINT numElements = ARRAYSIZE( layout );
	GetAttachedFileName(filepath, _T("vs_point_color.cso"));
	m_pVertexShader = m_comShader->LoadVertexShader(filepath, "main", "vs_4_0", layout, numElements, &m_pVertexLayout);


//Geometry Shader-----------------------------------------
	GetAttachedFileName(filepath, _T("gs_point_color.cso"));
	m_pGeometryShader = m_comShader->LoadGeometryShader(filepath, "main", "gs_4_0");

//Pixel Shader-----------------------------------------
	GetAttachedFileName(filepath, _T("ps_point_color.cso"));
	m_pPixelShader = m_comShader->LoadPixelShader(filepath, "main", "ps_4_0");

//-----------------------------------------------------------------------
//Constant buffer̍쐬
//constant bufferƂ́AJʒu⃏[hϊsȂ,
//CPUGPŮeXbhɃANZXobt@.
//[hs:fglobalԂɐݒuƂ̈ʒu(sړ)(])Zbgs.
//r[s:J猩Wn֕ϊ.
//ˉes:2W֕ϊ


	//projection, view, world matrixes
	D3D11_BUFFER_DESC bd;
	bd.ByteWidth = sizeof( mat44f )*3 + sizeof(float)*4;	//16̔{łKv//
    bd.Usage = D3D11_USAGE_DYNAMIC;
    bd.BindFlags = D3D11_BIND_CONSTANT_BUFFER;
	bd.CPUAccessFlags = D3D11_CPU_ACCESS_WRITE;	//CPȔ
	bd.MiscFlags = 0;
	bd.StructureByteStride=0;
	//SUBRESOURCEɂ鏉l͐ݒ肵Ȃ

    HRESULT hr = m_dx11_core->pd3dDevice->CreateBuffer( &bd, NULL, &m_pWVPBuffer );
    if( FAILED( hr ) )
        return hr;

/*	//Light position.
	bd.ByteWidth = sizeof( float )*4;	
	hr = pd3dDevice->CreateBuffer( &bd, NULL, &m_pLightBuffer );
    if( FAILED( hr ) )
        return hr;
*/	

//-----------------------------------------------------------
//eNX`̓ǂݍ.
	

	//hr = D3DX11CreateShaderResourceViewFromFile( m_dx11_core->pd3dDevice, m_texturepath, NULL, NULL, &m_pTextureRV, NULL );
	//	if( FAILED( hr ) ){
	//		m_pTextureRV = NULL;
	//	}
	//TEXTURE_INFO texInfo;
//	m_pTextureRV = m_comTexture->LoadTexture(m_texturepath, NULL,NULL);

    // eNX`̃TvO(|S\t̕)@̎w.
    D3D11_SAMPLER_DESC sampDesc;
    ZeroMemory( &sampDesc, sizeof(sampDesc) );
    sampDesc.Filter = D3D11_FILTER_MIN_MAG_MIP_LINEAR;
    sampDesc.AddressU = D3D11_TEXTURE_ADDRESS_WRAP;
    sampDesc.AddressV = D3D11_TEXTURE_ADDRESS_WRAP;
    sampDesc.AddressW = D3D11_TEXTURE_ADDRESS_WRAP;
    sampDesc.ComparisonFunc = D3D11_COMPARISON_NEVER;
    sampDesc.MinLOD = 0;
    sampDesc.MaxLOD = D3D11_FLOAT32_MAX;
    hr = m_dx11_core->pd3dDevice->CreateSamplerState( &sampDesc, &m_pSampler );
    if( FAILED( hr ) )
        return hr;


// uhEXe[gEIuWFNg̍쐬
	// p[eBNpuhEXe[gEIuWFNg
	D3D11_BLEND_DESC BlendDesc;
	ZeroMemory(&BlendDesc, sizeof(D3D11_BLEND_DESC));
	BlendDesc.AlphaToCoverageEnable    = FALSE;
	BlendDesc.IndependentBlendEnable   = FALSE;
	BlendDesc.RenderTarget[0].BlendEnable           = TRUE;
	BlendDesc.RenderTarget[0].BlendOp               = D3D11_BLEND_OP_ADD;
	BlendDesc.RenderTarget[0].SrcBlend              = D3D11_BLEND_SRC_ALPHA;//D3D11_BLEND_ONE;
	BlendDesc.RenderTarget[0].DestBlend             = D3D11_BLEND_ONE;
	BlendDesc.RenderTarget[0].BlendOpAlpha          = D3D11_BLEND_OP_ADD;
	BlendDesc.RenderTarget[0].SrcBlendAlpha         = D3D11_BLEND_ZERO;
	BlendDesc.RenderTarget[0].DestBlendAlpha        = D3D11_BLEND_ZERO;
	BlendDesc.RenderTarget[0].RenderTargetWriteMask = D3D11_COLOR_WRITE_ENABLE_ALL;

	BlendFunc(&BlendDesc, DOG_SRC_ALPHA, DOG_ONE_MINUS_SRC_ALPHA);

	hr = m_dx11_core->pd3dDevice->CreateBlendState(&BlendDesc, &m_pBlendState);

	//[xobt@݂Ȃ.
// fvXEXe[gEIuWFNg̍쐬
	// p[eBNpfvXEXe[gEIuWFNg
	//|CgXvCgł̓fvXobt@̃`FbNāAXV͂Ȃ.
	D3D11_DEPTH_STENCIL_DESC DepthStencilState;
	ZeroMemory(&DepthStencilState, sizeof(D3D11_DEPTH_STENCIL_DESC));
	DepthStencilState.DepthEnable = TRUE;
	DepthStencilState.DepthWriteMask = D3D11_DEPTH_WRITE_MASK_ZERO;	//[xobt@݂Ȃ.
	DepthStencilState.DepthFunc = D3D11_COMPARISON_LESS;
	DepthStencilState.StencilEnable = FALSE;
	DepthStencilState.StencilReadMask = D3D11_DEFAULT_STENCIL_READ_MASK;
	DepthStencilState.StencilWriteMask = D3D11_DEFAULT_STENCIL_WRITE_MASK;
//	DepthStencilState.StencilFunc = D3D11_STENCIL_OP_KEEP;
//	DepthStencilState.StencilDepthFailOp = D3D11_STENCIL_OP_KEEP;
//	DepthStencilState.StencilPassOp = D3D11_STENCIL_OP_KEEP;
//	DepthStencilState.StencilFailOp = D3D11_COMPARISON_ALWAYS;
	hr = m_dx11_core->pd3dDevice->CreateDepthStencilState(&DepthStencilState, &m_pDepthStencilState);


    return S_OK;
}


void PointRendererDX11::Draw(UINT particle_count, vec3f* positions){

	//ϊs
	mat44f world_matrix;
	world_matrix.SetIdentity();
	
	//Blendݒ///////////////////////////////
	//ftHg̃uhXe[g.
	ID3D11BlendState*		org_pBlendState;
	FLOAT org_BlendFactor[4];
	UINT org_SampleMask;
	if(m_pBlendState){
		
		m_dx11_core->pd3dDC->OMGetBlendState(&org_pBlendState, org_BlendFactor, &org_SampleMask);
		m_dx11_core->pd3dDC->OMSetBlendState(m_pBlendState, org_BlendFactor, org_SampleMask);
		
	}
	//XeVݒ////////////////////////////////////
	//ftHg̃XeVXe[g.
	ID3D11DepthStencilState*		org_pDepthStencilState;
	UINT org_StencilRef;
	if(m_pDepthStencilState){
		m_dx11_core->pd3dDC->OMGetDepthStencilState(&org_pDepthStencilState, &org_StencilRef);
		m_dx11_core->pd3dDC->OMSetDepthStencilState(m_pDepthStencilState, 0);
	}

	// Set the input layout
    m_dx11_core->pd3dDC->IASetInputLayout( m_pVertexLayout );
    // Set primitive topology
    m_dx11_core->pd3dDC->IASetPrimitiveTopology(D3D11_PRIMITIVE_TOPOLOGY_POINTLIST);// D3D_PRIMITIVE_TOPOLOGY_POINTLIST );

	//萔obt@̏.
	D3D11_MAPPED_SUBRESOURCE mappedResource;
	m_dx11_core->pd3dDC->Map( m_pConstantBuffers[0], 0, D3D11_MAP_WRITE_DISCARD, 0,&mappedResource);
	CopyMemory(mappedResource.pData, &world_matrix, sizeof(mat44f));
	CopyMemory((mat44f*)mappedResource.pData + 1, m_pViewMatrix, sizeof(mat44f));
	CopyMemory((mat44f*)mappedResource.pData + 2, m_pProjectionMatrix, sizeof(mat44f));
	CopyMemory((mat44f*)mappedResource.pData + 3, &m_pPointSize, sizeof(vec2f));
	m_dx11_core->pd3dDC->Unmap( m_pConstantBuffers[0], 0);


	//obt@̃Zbg.	
    UINT offset = 0;
    UINT stride = sizeof( VERTEX_F3UI1 );
    m_dx11_core->pd3dDC->IASetVertexBuffers( 0, 1, &m_pVertexBuffer, &stride, &offset );

	
	//IȒ_obt@(CX^Xp)̍XV (UpdateSubresourcegꍇ).
	//ړĨobt@Usage = D3D11_USAGE_DEFAULT, CPUAccessFlags = 0.
	//ONULL̎VertexBuffer(VRAM)ƓTCYRs[̂,
	//Rs[(CPU)VertexBufferȏ̃TCYmۂĂȂ΂ȂȂ.
	//̂Ƃ܁EZ͖.
//	m_dx11_core->pd3dDC->UpdateSubresource( m_pVertexBuffer, 0, NULL, positions, 0, 0);//sizeof(vec3f) * particle_count
	//: Map/UnmapUpdateSubresourceł͖wǑx͂Ȃ.


    // Render materials
	m_dx11_core->pd3dDC->VSSetShader( m_pVertexShader, NULL, 0 );
	m_dx11_core->pd3dDC->VSSetConstantBuffers(0, 1, m_pConstantBuffers);
	
	m_dx11_core->pd3dDC->GSSetShader( m_pGeometryShader, NULL, 0 );
	m_dx11_core->pd3dDC->GSSetConstantBuffers(0, 1, m_pConstantBuffers);
		
	m_dx11_core->pd3dDC->PSSetShader( m_pPixelShader, NULL, 0 );
//	m_dx11_core->pd3dDC->PSSetShaderResources( 0, 1, &(m_pTextureRV) );
	m_dx11_core->pd3dDC->PSSetSamplers( 0, 1, &m_pSampler );
	m_dx11_core->pd3dDC->Draw( particle_count, 0);

	//Blendݒ///////////////////////////////
	if(m_pBlendState){
		m_dx11_core->pd3dDC->OMSetBlendState(org_pBlendState, org_BlendFactor, org_SampleMask);
	}
	if(m_pDepthStencilState){
		m_dx11_core->pd3dDC->OMSetDepthStencilState(org_pDepthStencilState, org_StencilRef);
	}
}


/////////////////////////////////////////////////////////////////
//
//Rendering by OpenGL
//
/////////////////////////////////////////////////////////////////


//VBO̐ݒ
void PointRendererDX11::Draw(ATOMS_DATA* dat, BOND_INFO* bond, const VISUAL_SETTING& vis){	//int j_mode, float Jmax
	

	//ATOMS_DATA* dat = GetDataPointer();
	if (dat == NULL) return;
	
	
	//vbõZbg
	int redraw_flag = 0;
	if(vis.atom_poly != m_prev_vis.atom_poly){
		redraw_flag = 1;
	}

	//q\F̃[hݒ//
	if(vis.atom_color != m_prev_vis.atom_color){
		redraw_flag = 1;
	}

	if(dat != m_prev_render_dat){
		redraw_flag = 1;
	}

	
	//J[e[u
	if(redraw_flag){
		if(vis.atom_color ==  VISUAL_ATOMCOLOR_BONDNUM){
			//if(dat->bondInsideCnt == -1){
				CheckColorByBondNum2(dat, bond);
			//}else{
			//	CheckColorByBondNum(dat);
			//}
		}else if(vis.atom_color ==  VISUAL_ATOMCOLOR_PRESSURE){
			//if(dat->bondInsideCnt == -1){
				CheckColorByPressure(dat, bond);
			//}else{
			//	CheckColorByBondNum(dat);
			//}
		}else{	//MODE_COLOR_ATOMIC
			CheckColorByAtomKind(dat);
		}
	}

	
	//q̕`//
	if(vis.atom){
		const int count = dat->pcnt;
		if(vis.bond){redraw_flag = 1;}
		
		//_̌vZ//
		size_t num_draw_once = g_max_vram_size / (sizeof(VERTEX_F3UI1));
		if(count > num_draw_once){//_̃obt@TCY𒴂ꍇ͕ɕĕ`悷//
			redraw_flag = 1;
		}

		size_t i_start = 0;
		while(i_start < count){

			if(i_start + num_draw_once > count){ num_draw_once = count - i_start;};

			
			if(redraw_flag){

				CreateSphere(i_start, num_draw_once, dat, bond);
			}
			

			if(m_vbo_vcount){
	
				UpdateVertexBuffer(m_vbo_vertex, m_vbo_vcount, sizeof(VERTEX_F3UI1));	//_f[^VRAMɓ]
				//UpdateIndexBuffer(m_vbo_indexes, m_vbo_icount, sizeof(int));	//CfbNXf[^VRAMɓ]
	
			//	Disable(DOG_BLEND);
				Draw(m_vbo_vcount, NULL);
			}

			i_start += num_draw_once;
		}
			
	}



	
	m_prev_render_dat = dat;
	m_prev_vis = vis;
}


void PointRendererDX11::CreateSphere(int start, int count, ATOMS_DATA* dat, BOND_INFO* bond){
	
	//vboTCY
	int vbo_v_count = count;
	int need_vram_sz = vbo_v_count * sizeof(VERTEX_F3UI1);

	
	//ATOMS_DATA* dat = GetDataPointer();
	if(m_vram_size < need_vram_sz){
		m_vram_size = need_vram_sz;

		delete [] m_vbo_vertex;	
		m_vbo_vertex = new VERTEX_F3UI1[vbo_v_count];
	}



	m_vbo_vcount = 0;
	
	

	
	//q()̃Zbg
	const int i_end = start + count;
	for(int i = start; i < i_end; i++){
		if(m_color_table[i] & 0xFF000000){	//S߂͕\Ȃ//
			m_vbo_vertex[m_vbo_vcount].position = dat->r[i];
			m_vbo_vertex[m_vbo_vcount].color = m_color_table[i];

			m_vbo_vcount ++;
		}
	}

	
}

///////////////////////////////////////////////
//
//VBOɃ|SZbg@\
//
////////////////////////////////////////////////
	

//qԍɃJ[vZ
void PointRendererDX11::CheckColorByAtomKind( ATOMS_DATA* dat){
	
	//ATOMS_DATA* dat = GetDataPointer();

	delete [] m_color_table;
	m_color_table = new unsigned int[dat->pcnt];
	
	//FQ
	int i;
	for(i = 0; i < dat->pcnt; i++){
		m_color_table[i] = *(((unsigned int*)atom_colors) + dat->knd[i]);
	}
}


//{hɃJ[vZ
void PointRendererDX11::CheckColorByBondNum2( ATOMS_DATA* dat, BOND_INFO* bond){
	
	//ATOMS_DATA* dat = GetDataPointer();

	delete [] m_color_table;
	m_color_table = new unsigned int[dat->pcnt];
	memset(m_color_table, 0, sizeof(unsigned int) * dat->pcnt);

	//bondvZ
	
	//FQ
	for(int i = 0; i < dat->pcnt; i++){
		if(bond->coords[i] >= COLOR_LIMIT_BOND){
			m_color_table[i] = *(((unsigned int*)bondnum_colors) + COLOR_LIMIT_BOND - 1);
		}else{
			m_color_table[i] = *(((unsigned int*)bondnum_colors) + bond->coords[i]);
		}
	}
}


//{hɃJ[vZ
void PointRendererDX11::CheckColorByPressure( ATOMS_DATA* dat, BOND_INFO* bond){
	
	//ATOMS_DATA* dat = GetDataPointer();

	delete [] m_color_table;
	m_color_table = new unsigned int[dat->pcnt];
	memset(m_color_table, 0, sizeof(unsigned int) * dat->pcnt);

	//bondvZ
	
	//FQ
	for(int i = 0; i < dat->pcnt; i++){
		m_color_table[i] = bond->coords[i];
	}
}

void PointRendererDX11::ClearVRAM(){
	m_prev_render_dat = NULL;

}