// PointRendererDX11.h: PointRendererDX11 NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#ifndef PointRendererDX11_h
#define PointRendererDX11_h

#pragma once
#define _CRT_SECURE_NO_WARNINGS

#include "MDLoader.h"	//ATOMS_DATÂ߂ɕKv//
#include "BOND_INFO.h"

//#include "sdkwgl.h"
#include "vec3.h"
#include "mat33.h"
#include "mat44.h"
#include "io64.h"
#include "mod.h"


#include "visual.h"


#include "rowdog.h"
#include "BasicRenderer.h"
#include <d3d11.h>


#include <d3d11.h>


struct VERTEX_F3UI1 {
	vec3f position;
	unsigned int color;
};

class PointRendererDX11 : public BasicRenderer{
private:

	ID3D11GeometryShader*     m_pGeometryShader;
	//ID3D11ShaderResourceView* m_pTextureRV;
	ID3D11SamplerState*     m_pSampler;
	ID3D11DepthStencilState*		m_pDepthStencilState;


	struct vec2f{
		float	x;
		float	y;
	} m_pPointSize;

	TCHAR* m_texturepath;

private:




	int m_vram_size;
	int m_vbo_vcount;
	VERTEX_F3UI1* m_vbo_vertex;
	
	unsigned int *m_color_table;	//qƂ̐F

	ATOMS_DATA* m_prev_render_dat;	//O񃌃_Of[^
	void CreateSphere(int start, int count, ATOMS_DATA* dat, BOND_INFO* bond);

	
	
	void CheckColorByBondNum( ATOMS_DATA* dat);
	void CheckColorByBondNum2( ATOMS_DATA* dat, BOND_INFO* bond);
	void CheckColorByAtomKind( ATOMS_DATA* dat);
	void CheckColorByPressure( ATOMS_DATA* dat, BOND_INFO* bond );
	
	//\[h
//	int m_visual_atom;	//q̕\TCY

//	int m_visual_atompoly;	//q̃|S(ܓx̕B2ȏBox͈̕ܓx̔{ɂȂ)

	VISUAL_SETTING m_prev_vis;




//ROWDOG///////////////////////
	/*
	void UpdateVertexBuffer(LPVOID pBuffer, UINT count, UINT stride);
	void UpdateIndexBuffer(LPVOID pBuffer, UINT count, UINT stride);
	virtual void Draw(UINT index_count, vec3f* position);
*/
	float Jmax;

	HRESULT InitShader();
	void Draw(UINT index_count, vec3f* positions);

public:
	
	PointRendererDX11(DX11_CORE* dx11_core, CommonShader* comShader);
	virtual ~PointRendererDX11();


	void Draw(ATOMS_DATA* dat, BOND_INFO* bond, const VISUAL_SETTING& vis);

	void SetMode(int type, int mode, ATOMS_DATA* dat);
	void ClearVRAM();	

	//void SetParam(int type, void* params);
	
//	void SetViewMatrixPointer(mat44f* pViewMatrix );
//	void SetProjectionMatrixPointer(mat44f* pProjectionMatrix );

	
};





#endif // PointRendererDX11

