
#ifndef __camera_h__
#define __camera_h__


#pragma once

#include <stdlib.h>
#include <stdio.h>
#include <math.h>



#define WIN32_LEAN_AND_MEAN             // Windows wb_[gpĂȂO܂B
#include <windows.h>
#include <GL/gl.h>		//OpenGLpɕKv<br />
#include <GL/glu.h>		//gluPerspectiveg߂ɃCN[h

#include <tchar.h>

#include "vec3.h"

#pragma comment( lib , "opengl32.lib" )	//OpenGLpCuN
#pragma comment( lib , "glu32.lib" )	//glu֐pCuN

class CameraGL  
{
private:
	vec3d m_target;
	vec3d m_camera;
	vec3d m_up;

	vec3d m_target_mem;
	vec3d m_camera_mem;
	vec3d m_up_mem;
	
	double m_drag_distance;
	vec3d m_drag_org;
	vec3d m_drag_up;
	vec3d m_drag_front;
	vec3d m_drag_right;
	

	void RotateOnAxis(vec3d* a, vec3d* v, double rad);
	void RotateOnAxis(vec3d* a, vec3d* v1, vec3d* v2, double rad);
	void OuterProd(vec3d* u, vec3d* v, vec3d* a);

	
	struct CHKPOINT{
		CHKPOINT* next;
		int frame;
		int overblow;
		//CAMERA_INFO caminfo;
		vec3d target;
		vec3d camera;
		vec3d up;
	};
	
	CHKPOINT* m_chkpoint_fst;
	CHKPOINT* m_chkpoint_current;
	CHKPOINT* m_chkpoint_last;
	int m_playtm;	//`FbN|CgԂ̃t[(Đ̓`FbN|Cgʉ߂̓x0ɂȂ)

	void DeleteAllCheckPoint();

public:
	
	CameraGL();
	virtual ~CameraGL();
	
	void Init(double max_side, double center_x, double center_y, double center_z);
	void DragStart();
	void DragTranslate(double dx, double dy, double w, double h);
	void DragRotate(double dx, double dy, double w, double h);
	
	void GetRAY(double x, double y, double w, double h, vec3d* vray, vec3d* vorg);

	void SetGLCamera();

	void RotatePosOnUpAxis(double rad);
	void RotatePosToUp(double rad);
	void FocusDown(double r);
	void RotatePosOnZAxis(double rad);
	void TargetMoveToZ(double z);
	void TargetMoveToUp(double d);
	void TargetMoveToSide(double d);
	void TargetMoveToFront(double d);
	void SetYawPitchRoll(double yaw, double pitch, double roll);
	void SetRotationMatrix(const float* matrix);

	double GetForcusDistance();
	//void SetForcusDistance(double distance);

	void SetStereoMode(double ratio);
	void PushState();
	void PullState();

	
	void InsertCheckPoint(int frame, int overblow);
	int PlayCheckPoint(int* pframe, int frameskip);
	void RewindCheckPoint();

	void SaveCheckPoint(const TCHAR* filename);
	void LoadCheckPoint(const TCHAR* filename);

	void GetDirection(vec3d *target, vec3d *camera){
		*target = m_target;
		*camera = m_camera;
	};

	template<class T>
	void GetInfo(T *target, T *camera, T *up){
		*target = (T)m_target;
		*camera = (T)m_camera;
		*up = (T)m_up;
	};

	/*
	void GetFloatInfo(vec3f *target, vec3f *camera, vec3f *up){
		*target = (vec3f)m_target;
		*camera = (vec3f)m_camera;
		*up= (vec3f)m_up;
	};
	*/
	
	void SetViewFront(int section, int sprit);
	void ResetViewFront();

};

#endif // __camera_h__