
#ifndef __filelist_h__
#define __filelist_h__


#include "MDLoader.h"
#include "Field3DLoader.h"
#include "trajectory.h"
#include "LMC_Holder.h"


enum FILETYPE{
	FILETYPE_NULL,
	FILETYPE_ATOM,
	FILETYPE_TRAJ,
	FILETYPE_FIELD,
	FILETYPE_LMC,
};



struct FileInfo{
	
	TCHAR* filepath;
	size_t dirlen;		//directory̍Ō\܂Ŋ܂񂾒
	TCHAR* filename;	//filepath̐擪ʒu
	TCHAR* ext;			//filepath̐擪ʒu
	FILETYPE type;

	BOND_INFO bond;
	

	//t@C[_[.
	union{
		MDLoader* atm;
		BCALoader* bca;
		Field3DLoader* field;
		LMC_Holder* lmc;
	};

	
	FileInfo() : 
		
		filepath(NULL),
		dirlen(0),
		filename(NULL),
		ext(NULL),
		type(FILETYPE_NULL)
	{

	};
	virtual ~FileInfo(){
		delete [] filepath;
		switch(type){
			case FILETYPE_ATOM:	
				delete atm;	
//				delete atomRenderer;	
				break;
			case FILETYPE_TRAJ:	
				delete bca;
				break;
			case FILETYPE_FIELD:	
				delete field;	
				break;
			case FILETYPE_LMC:	
				delete lmc;	
//				delete lmcRenderer;	
				break;
		}
	};
};



typedef std::vector<FileInfo*> VP_FileList;
typedef VP_FileList::iterator ITP_FileList;


#endif	//__filelist_h__
